## llvm-toolchain-snapshot 22~++20251225060819+966ae44e638b

=== libcxxabi/CMakeLists.txt ===
# See www/CMake.html for instructions on how to build libcxxabi with CMake.

#===============================================================================
# Setup Project
#===============================================================================

cmake_minimum_required(VERSION 3.20.0)
set(LLVM_SUBPROJECT_TITLE "libc++abi")

set(LLVM_COMMON_CMAKE_UTILS "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

# Add path for custom modules
list(INSERT CMAKE_MODULE_PATH 0
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  "${CMAKE_CURRENT_SOURCE_DIR}/../runtimes/cmake/Modules"
  "${LLVM_COMMON_CMAKE_UTILS}"
  "${LLVM_COMMON_CMAKE_UTILS}/Modules"
  )

set(CMAKE_FOLDER "libc++")

set(LIBCXXABI_SOURCE_DIR  ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBCXXABI_BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR})
set(LIBCXXABI_LIBCXX_PATH "${CMAKE_CURRENT_LIST_DIR}/../libcxx" CACHE PATH
        "Specify path to libc++ source.")

include(GNUInstallDirs)

# Require out of source build.
include(MacroEnsureOutOfSourceBuild)
MACRO_ENSURE_OUT_OF_SOURCE_BUILD(
 "${PROJECT_NAME} requires an out of source build. Please create a separate
 build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there."
 )

if (MSVC)
  message(FATAL_ERROR "Libc++abi can't be built for MSVC targets, and doing so is pointless anyway because such "
                      "targets must use the MS C++ ABI, and libc++abi provides the Itanium C++ ABI.")
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================
include(CMakeDependentOption)
include(HandleCompilerRT)

# Define options.
option(LIBCXXABI_ENABLE_EXCEPTIONS
  "Provide support for exceptions in the runtime.
  When disabled, libc++abi does not support stack unwinding and other exceptions-related features." ON)
option(LIBCXXABI_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBCXXABI_ENABLE_PEDANTIC "Compile with pedantic enabled." OFF)
option(LIBCXXABI_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBCXXABI_USE_LLVM_UNWINDER "Build and use the LLVM unwinder." ON)
if (LIBCXXABI_USE_LLVM_UNWINDER AND NOT "libunwind" IN_LIST LLVM_ENABLE_RUNTIMES)
  message(FATAL_ERROR "LIBCXXABI_USE_LLVM_UNWINDER is set to ON, but libunwind is not specified in LLVM_ENABLE_RUNTIMES.")
endif()
option(LIBCXXABI_ENABLE_STATIC_UNWINDER "Statically link the LLVM unwinder." OFF)
option(LIBCXXABI_USE_COMPILER_RT "Use compiler-rt instead of libgcc" OFF)
option(LIBCXXABI_ENABLE_THREADS "Build with threads enabled" ON)
option(LIBCXXABI_HAS_PTHREAD_API "Ignore auto-detection and force use of pthread API" OFF)
option(LIBCXXABI_HAS_WIN32_THREAD_API "Ignore auto-detection and force use of win32 thread API" OFF)
option(LIBCXXABI_HAS_EXTERNAL_THREAD_API
  "Build libc++abi with an externalized threading API.
  This option may only be set to ON when LIBCXXABI_ENABLE_THREADS=ON." OFF)
option(LIBCXXABI_ENABLE_FORGIVING_DYNAMIC_CAST
"Make dynamic_cast more forgiving when type_info's mistakenly have hidden \
visibility, and thus multiple type_infos can exist for a single type. \
When the dynamic_cast would normally fail, this option will cause the \
library to try comparing the type_info names to see if they are equal \
instead." OFF)

option(LIBCXXABI_ENABLE_NEW_DELETE_DEFINITIONS
  "Build libc++abi with definitions for operator new/delete. These are normally
   defined in libc++abi, but it is also possible to define them in libc++, in
   which case the definition in libc++abi should be turned off." ON)
option(LIBCXXABI_BUILD_32_BITS "Build 32 bit multilib libc++abi. This option is not supported anymore when building the runtimes. Please specify a full triple instead." ${LLVM_BUILD_32_BITS})
if (LIBCXXABI_BUILD_32_BITS)
  message(FATAL_ERROR "LIBCXXABI_BUILD_32_BITS is not supported anymore when building the runtimes, please specify a full triple instead.")
endif()

option(LIBCXXABI_INCLUDE_TESTS "Generate build targets for the libc++abi unit tests." ${LLVM_INCLUDE_TESTS})
set(LIBCXXABI_LIBDIR_SUFFIX "${LLVM_LIBDIR_SUFFIX}" CACHE STRING
    "Define suffix of library directory name (32/64)")
option(LIBCXXABI_INSTALL_HEADERS "Install the libc++abi headers." ON)
option(LIBCXXABI_INSTALL_LIBRARY "Install the libc++abi library." ON)

set(LIBCXXABI_SHARED_OUTPUT_NAME "c++abi" CACHE STRING "Output name for the shared libc++abi runtime library.")
set(LIBCXXABI_STATIC_OUTPUT_NAME "c++abi" CACHE STRING "Output name for the static libc++abi runtime library.")

set(LIBCXXABI_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}/c++/v1" CACHE STRING "Path to install the libc++abi headers at.")

if(LLVM_LIBRARY_OUTPUT_INTDIR)
  set(LIBCXXABI_GENERATED_INCLUDE_DIR "${LLVM_BINARY_DIR}/include/c++/v1")
else()
  set(LIBCXXABI_GENERATED_INCLUDE_DIR "${CMAKE_BINARY_DIR}/include/c++/v1")
endif()

set(LIBCXXABI_LIBCXX_LIBRARY_PATH "" CACHE PATH "The path to libc++ library.")
set(LIBCXXABI_LIBRARY_VERSION "1.0" CACHE STRING
"Version of libc++abi. This will be reflected in the name of the shared \
library produced. For example, -DLIBCXXABI_LIBRARY_VERSION=x.y will \
result in the library being named libc++abi.x.y.dylib, along with the \
usual symlinks pointing to that.")

# Default to building a shared library so that the default options still test
# the libc++abi that is being built. The problem with testing a static libc++abi
# is that libc++ will prefer a dynamic libc++abi from the system over a static
# libc++abi from the output directory.
option(LIBCXXABI_ENABLE_SHARED "Build libc++abi as a shared library." ON)
option(LIBCXXABI_ENABLE_STATIC "Build libc++abi as a static library." ON)

cmake_dependent_option(LIBCXXABI_INSTALL_STATIC_LIBRARY
  "Install the static libc++abi library." ON
  "LIBCXXABI_ENABLE_STATIC;LIBCXXABI_INSTALL_LIBRARY" OFF)
cmake_dependent_option(LIBCXXABI_INSTALL_SHARED_LIBRARY
  "Install the shared libc++abi library." ON
  "LIBCXXABI_ENABLE_SHARED;LIBCXXABI_INSTALL_LIBRARY" OFF)

cmake_dependent_option(LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_STATIC_LIBRARY
  "Statically link the LLVM unwinder to static library" ON
  "LIBCXXABI_ENABLE_STATIC_UNWINDER" OFF)
cmake_dependent_option(LIBCXXABI_STATICALLY_LINK_UNWINDER_IN_SHARED_LIBRARY
  "Statically link the LLVM unwinder to shared library" ON
  "LIBCXXABI_ENABLE_STATIC_UNWINDER" OFF)

option(LIBCXXABI_BAREMETAL "Build libc++abi for baremetal targets." OFF)
# The default terminate handler attempts to demangle uncaught exceptions, which
# causes extra I/O and demangling code to be pulled in.
option(LIBCXXABI_SILENT_TERMINATE "Set this to make the terminate handler default to a silent alternative" OFF)
option(LIBCXXABI_NON_DEMANGLING_TERMINATE "Set this to make the terminate handler
avoid demangling" OFF)

if (NOT LIBCXXABI_ENABLE_SHARED AND NOT LIBCXXABI_ENABLE_STATIC)
  message(FATAL_ERROR "libc++abi must be built as either a shared or static library.")
endif()

set(LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT OFF)
if (WIN32)
  set(LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT ON)
endif()
option(LIBCXXABI_HERMETIC_STATIC_LIBRARY
  "Do not export any symbols from the static library." ${LIBCXXABI_HERMETIC_STATIC_LIBRARY_DEFAULT})

if(MINGW)
  set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-mingw.cfg.in")
elseif(WIN32) # clang-cl
  if (LIBCXXABI_ENABLE_SHARED)
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-shared-clangcl.cfg.in")
  else()
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-static-clangcl.cfg.in")
  endif()
else()
  if (LIBCXXABI_ENABLE_SHARED)
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-shared.cfg.in")
  else()
    set(LIBCXXABI_DEFAULT_TEST_CONFIG "llvm-libc++abi-static.cfg.in")
  endif()
endif()
set(LIBCXXABI_TEST_CONFIG "${LIBCXXABI_DEFAULT_TEST_CONFIG}" CACHE STRING
  "The path to the Lit testing configuration to use when running the tests.
   If a relative path is provided, it is assumed to be relative to '<monorepo>/libcxxabi/test/configs'.")
if (NOT IS_ABSOLUTE "${LIBCXXABI_TEST_CONFIG}")
  set(LIBCXXABI_TEST_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/test/configs/${LIBCXXABI_TEST_CONFIG}")
endif()
message(STATUS "Using libc++abi testing configuration: ${LIBCXXABI_TEST_CONFIG}")
set(LIBCXXABI_TEST_PARAMS "" CACHE STRING
    "A list of parameters to run the Lit test suite with.")

#===============================================================================
# Configure System
#===============================================================================

# Add path for custom modules
set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  ${CMAKE_MODULE_PATH}
  )

set(LIBCXXABI_INSTALL_RUNTIME_DIR "${CMAKE_INSTALL_BINDIR}" CACHE STRING
    "Path where built libc++abi runtime libraries should be installed.")

if(LLVM_ENABLE_PER_TARGET_RUNTIME_DIR AND NOT APPLE)
  set(LIBCXXABI_TARGET_SUBDIR ${LLVM_DEFAULT_TARGET_TRIPLE})
  if(LIBCXXABI_LIBDIR_SUBDIR)
    string(APPEND LIBCXXABI_TARGET_SUBDIR /${LIBCXXABI_LIBDIR_SUBDIR})
  endif()
  cmake_path(NORMAL_PATH LIBCXXABI_TARGET_SUBDIR)
  set(LIBCXXABI_HEADER_DIR ${LLVM_BINARY_DIR})
  set(LIBCXXABI_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR}/${LIBCXXABI_TARGET_SUBDIR})
  set(LIBCXXABI_INSTALL_LIBRARY_DIR lib${LLVM_LIBDIR_SUFFIX}/${LIBCXXABI_TARGET_SUBDIR} CACHE STRING
      "Path where built libc++abi libraries should be installed.")
  set(LIBCXXABI_INSTALL_INCLUDE_TARGET_DIR "${CMAKE_INSTALL_INCLUDEDIR}/${LIBCXXABI_TARGET_SUBDIR}/c++/v1" CACHE STRING
      "Path where target-specific libc++abi headers should be installed.")
  unset(LIBCXXABI_TARGET_SUBDIR)
else()
  if(LLVM_LIBRARY_OUTPUT_INTDIR)
    set(LIBCXXABI_HEADER_DIR ${LLVM_BINARY_DIR})
    set(LIBCXXABI_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR})
  else()
    set(LIBCXXABI_HEADER_DIR ${CMAKE_BINARY_DIR})
    set(LIBCXXABI_LIBRARY_DIR ${CMAKE_BINARY_DIR}/lib${LIBCXXABI_LIBDIR_SUFFIX})
  endif()
  set(LIBCXXABI_INSTALL_LIBRARY_DIR lib${LIBCXXABI_LIBDIR_SUFFIX} CACHE STRING
      "Path where built libc++abi libraries should be installed.")
  set(LIBCXXABI_INSTALL_INCLUDE_TARGET_DIR "${LIBCXXABI_INSTALL_INCLUDE_DIR}" CACHE STRING
      "Path where target-specific libc++abi headers should be installed.")
endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LIBCXXABI_LIBRARY_DIR})

# By default, libcxx and libcxxabi share a library directory.
if (NOT LIBCXXABI_LIBCXX_LIBRARY_PATH)
  set(LIBCXXABI_LIBCXX_LIBRARY_PATH "${LIBCXXABI_LIBRARY_DIR}" CACHE PATH
      "The path to libc++ library." FORCE)
endif()

# Declare libc++abi configuration variables.
# They are intended for use as follows:
# LIBCXXABI_C_FLAGS: General flags for both the c++ compiler and linker.
# LIBCXXABI_CXX_FLAGS: General flags for both the c++ compiler and linker.
# LIBCXXABI_COMPILE_FLAGS: Compile only flags.
# LIBCXXABI_LINK_FLAGS: Linker only flags.
# LIBCXXABI_LIBRARIES: libraries libc++abi is linked to.

set(LIBCXXABI_C_FLAGS "")
set(LIBCXXABI_CXX_FLAGS "")
set(LIBCXXABI_COMPILE_FLAGS "")
set(LIBCXXABI_LINK_FLAGS "")
set(LIBCXXABI_LIBRARIES "")
set(LIBCXXABI_ADDITIONAL_COMPILE_FLAGS "" CACHE STRING "See documentation LIBCXX_ADDITIONAL_COMPILE_FLAGS")
set(LIBCXXABI_ADDITIONAL_LIBRARIES "" CACHE STRING
    "Additional libraries libc++abi is linked to which can be provided in cache")

# Include macros for adding and removing libc++abi flags.
include(HandleLibcxxabiFlags)

#===============================================================================
# Setup Compiler Flags
#===============================================================================

# Configure target flags
if ("${CMAKE_SYSTEM_NAME}" MATCHES "AIX")
  add_flags_if_supported("-mdefault-visibility-export-mapping=explicit")
  set(CMAKE_AIX_EXPORT_ALL_SYMBOLS OFF)
endif()
add_library_flags("${LIBCXXABI_ADDITIONAL_LIBRARIES}")

=== libc/include/CMakeLists.txt ===
set(LIBC_INCLUDE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBC_INCLUDE_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

include(LLVMLibCHeaderRules)

# The GPU build wants to install files in the compiler's resource directory.
if(LIBC_TARGET_OS_IS_GPU)
  include(GetClangResourceDir)
endif()

add_subdirectory(llvm-libc-macros)
add_subdirectory(llvm-libc-types)

add_header(
  llvm_libc_common_h
  HDR
    __llvm-libc-common.h
)

# TODO: Can we simplify this macro expansion?
# https://github.com/llvm/llvm-project/issues/117254
macro(add_header_macro TARGET_NAME YAML_FILE GEN_HDR DEPENDS)
  add_gen_header(
    ${TARGET_NAME}
    YAML_FILE ${YAML_FILE}
    GEN_HDR ${GEN_HDR}
    ${DEPENDS}
    ${ARGN}
  )
endmacro()

add_header_macro(
  ctype
  ../libc/include/ctype.yaml
  ctype.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.locale_t
)

add_header_macro(
  dirent
  ../libc/include/dirent.yaml
  dirent.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.ino_t
    .llvm-libc-types.DIR
    .llvm-libc-types.struct_dirent
)

add_header_macro(
  fcntl
  ../libc/include/fcntl.yaml
  fcntl.h
  DEPENDS
    .llvm-libc-macros.fcntl_macros
    .llvm-libc-types.mode_t
    .llvm-libc-types.struct_flock
    .llvm-libc-types.struct_flock64
    .llvm-libc-types.off64_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.off_t
    .llvm_libc_common_h
)

add_header_macro(
  dlfcn
  ../libc/include/dlfcn.yaml
  dlfcn.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.dl_info
)

add_header_macro(
  endian
  ../libc/include/endian.yaml
  endian.h
  DEPENDS
    .llvm-libc-macros.endian_macros
    .llvm_libc_common_h
)

add_header_macro(
  features
  ../libc/include/features.yaml
  features.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.features_macros
)

add_header_macro(
  fenv
  ../libc/include/fenv.yaml
  fenv.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.fenv_macros
    .llvm-libc-types.fenv_t
    .llvm-libc-types.fexcept_t
)

add_header_macro(
  stdint
  ../libc/include/stdint.yaml
  stdint.h
  DEPENDS
    .llvm-libc-macros.stdint_macros
)

add_header_macro(
  inttypes
  ../libc/include/inttypes.yaml
  inttypes.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.imaxdiv_t
    .llvm-libc-macros.inttypes_macros
    .stdint
)

add_header_macro(
  float
  ../libc/include/float.yaml
  float.h
  DEPENDS
    .llvm-libc-macros.float_macros
)

add_header_macro(
  limits
  ../libc/include/limits.yaml
  limits.h
  DEPENDS
    .llvm-libc-macros.limits_macros
)

add_header_macro(
  malloc
  ../libc/include/malloc.yaml
  malloc.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.malloc_macros
)

add_header_macro(
  math
  ../libc/include/math.yaml
  math.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.float16_macros
    .llvm-libc-macros.math_macros
    .llvm-libc-macros.math_function_macros
    .llvm-libc-types.double_t
    .llvm-libc-types.float_t
    .llvm-libc-types.float128
)

add_header_macro(
  stdfix
  ../libc/include/stdfix.yaml
  stdfix.h
  DEPENDS
    .llvm-libc-macros.stdfix_macros
    .llvm-libc-types.int_hk_t
    .llvm-libc-types.int_hr_t
    .llvm-libc-types.int_k_t
    .llvm-libc-types.int_lk_t
    .llvm-libc-types.int_lr_t
    .llvm-libc-types.int_r_t
    .llvm-libc-types.uint_uhk_t
    .llvm-libc-types.uint_uhr_t
    .llvm-libc-types.uint_uk_t
    .llvm-libc-types.uint_ulk_t
    .llvm-libc-types.uint_ulr_t
    .llvm-libc-types.uint_ur_t
)


add_header_macro(
  sysexits
  ../libc/include/sysexits.yaml
  sysexits.h
  DEPENDS
    .llvm-libc-macros.sysexits_macros
)


# TODO: This should be conditional on POSIX networking being included.
file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/arpa)

add_header_macro(
  arpa_inet
  ../libc/include/arpa/inet.yaml
  arpa/inet.h
  DEPENDS
    .llvm_libc_common_h
    .inttypes
    .llvm-libc-types.in_addr
    .llvm-libc-types.in_addr_t
)

file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/netinet)

add_header_macro(
  netinet_in
  ../libc/include/netinet/in.yaml
  netinet/in.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.netinet_in_macros
)

add_header_macro(
  assert
  ../libc/include/assert.yaml
  assert.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.assert_macros
)

add_header_macro(
  complex
  ../libc/include/complex.yaml
  complex.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.complex_macros
    .llvm-libc-types.float128
    .llvm-libc-types.cfloat128
    .llvm-libc-types.cfloat16
)

add_header_macro(
  setjmp
  ../libc/include/setjmp.yaml
  setjmp.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.jmp_buf
    .llvm-libc-types.sigjmp_buf
)

add_header_macro(
  string
  ../libc/include/string.yaml
  string.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.null_macro
    .llvm-libc-types.size_t
)

add_header_macro(
  strings
  ../libc/include/strings.yaml
  strings.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.size_t
)

add_header_macro(
  search
  ../libc/include/search.yaml
  search.h
  DEPENDS
    .llvm-libc-types.ACTION
    .llvm-libc-types.ENTRY
    .llvm-libc-types.VISIT
    .llvm-libc-types.__search_compare_t
    .llvm-libc-types.size_t
    .llvm-libc-types.struct_hsearch_data
    .llvm_libc_common_h
)

add_header_macro(
  time
  ../libc/include/time.yaml
  time.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.time_macros
    .llvm-libc-types.clock_t
    .llvm-libc-types.time_t
    .llvm-libc-types.struct_tm
    .llvm-libc-types.struct_timespec
    .llvm-libc-types.struct_timeval
    .llvm-libc-types.clockid_t
)

add_header_macro(
  threads
  ../libc/include/threads.yaml
  threads.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.__call_once_func_t
    .llvm-libc-types.once_flag
    .llvm-libc-types.cnd_t
    .llvm-libc-types.mtx_t
    .llvm-libc-types.thrd_t
    .llvm-libc-types.thrd_start_t
    .llvm-libc-types.tss_t
    .llvm-libc-types.tss_dtor_t
)

add_header_macro(
  errno
  ../libc/include/errno.yaml
  errno.h
  DEPENDS
    .llvm-libc-macros.generic_error_number_macros
    .llvm-libc-macros.error_number_macros
)

add_header_macro(
  signal
  ../libc/include/signal.yaml
  signal.h
  DEPENDS
    .llvm-libc-macros.signal_macros
    .llvm-libc-types.pid_t
    .llvm-libc-types.sig_atomic_t
    .llvm-libc-types.sighandler_t
    .llvm-libc-types.siginfo_t
    .llvm-libc-types.sigset_t
    .llvm-libc-types.stack_t
    .llvm-libc-types.struct_sigaction
    .llvm-libc-types.union_sigval
)

add_header_macro(
  stdbit
  ../libc/include/stdbit.yaml
  stdbit.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.stdbit_macros
)

add_header_macro(
  stdckdint
  ../libc/include/stdckdint.yaml
  stdckdint.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.stdckdint_macros
)

add_header_macro(
  stdio
  ../libc/include/stdio.yaml
  stdio.h
  DEPENDS
    .llvm-libc-macros.file_seek_macros
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.stdio_macros
    .llvm-libc-types.FILE
    .llvm-libc-types.cookie_io_functions_t
    .llvm-libc-types.off_t
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
    .llvm_libc_common_h
)

add_header_macro(
  stdlib
  ../libc/include/stdlib.yaml
  stdlib.h
  DEPENDS
    .llvm-libc-macros.null_macro
    .llvm-libc-macros.stdlib_macros
    .llvm-libc-types.__atexithandler_t
    .llvm-libc-types.__qsortcompare_t
    .llvm-libc-types.__qsortrcompare_t
    .llvm-libc-types.__search_compare_t
    .llvm-libc-types.div_t
    .llvm-libc-types.ldiv_t
    .llvm-libc-types.lldiv_t
    .llvm-libc-types.locale_t
    .llvm-libc-types.size_t
    .llvm_libc_common_h
)

add_header_macro(
  unistd
  ../libc/include/unistd.yaml
  unistd.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.file_seek_macros
    .llvm-libc-macros.unistd_macros
    .llvm-libc-types.__exec_argv_t
    .llvm-libc-types.__exec_envp_t
    .llvm-libc-types.off_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
    .llvm-libc-types.uid_t
    .llvm-libc-types.__getoptargv_t
)

add_header_macro(
  pthread
  ../libc/include/pthread.yaml
  pthread.h
  DEPENDS
    .llvm-libc-macros.pthread_macros
    .llvm-libc-types.__atfork_callback_t
    .llvm-libc-types.__pthread_once_func_t
    .llvm-libc-types.__pthread_start_t
    .llvm-libc-types.__pthread_tss_dtor_t
    .llvm-libc-types.pthread_attr_t
    .llvm-libc-types.pthread_condattr_t
    .llvm-libc-types.pthread_key_t
    .llvm-libc-types.pthread_barrier_t
    .llvm-libc-types.pthread_barrierattr_t
    .llvm-libc-types.pthread_mutex_t
    .llvm-libc-types.pthread_mutexattr_t
    .llvm-libc-types.pthread_once_t
    .llvm-libc-types.pthread_rwlock_t
    .llvm-libc-types.pthread_rwlockattr_t
    .llvm-libc-types.pthread_spinlock_t
    .llvm-libc-types.pthread_t
    .llvm_libc_common_h
)

add_header_macro(
  sched
  ../libc/include/sched.yaml
  sched.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sched_macros
    .llvm-libc-types.cpu_set_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.size_t
    .llvm-libc-types.struct_sched_param
    # Needed according to posix standard
    .llvm-libc-types.time_t
    .llvm-libc-types.struct_timespec
)

add_header_macro(
  spawn
  ../libc/include/spawn.yaml
  spawn.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.mode_t
    .llvm-libc-types.pid_t
    .llvm-libc-types.posix_spawnattr_t
    .llvm-libc-types.posix_spawn_file_actions_t
)

add_header_macro(
  link
  ../libc/include/link.yaml
  link.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.link_macros
    .llvm-libc-types.struct_dl_phdr_info
    .llvm-libc-types.__dl_iterate_phdr_callback_t
)

add_header_macro(
  elf
  ../libc/include/elf.yaml
  elf.h
  DEPENDS
    .llvm-libc-macros.elf_macros
)

# TODO: Not all platforms will have a include/sys directory. Add the sys
# directory and the targets for sys/*.h files conditional to the OS requiring
# them.
file(MAKE_DIRECTORY ${LIBC_INCLUDE_DIR}/sys)

add_header_macro(
  sys_auxv
  ../libc/include/sys/auxv.yaml
  sys/auxv.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_auxv_macros
)

add_header_macro(
  sys_epoll
  ../libc/include/sys/epoll.yaml
  sys/epoll.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-types.struct_epoll_event
    .llvm-libc-types.struct_epoll_data
    .llvm-libc-types.sigset_t
    .llvm-libc-macros.sys_epoll_macros
)

add_header_macro(
  sys_ioctl
  ../libc/include/sys/ioctl.yaml
  sys/ioctl.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_ioctl_macros
)

add_header_macro(
  sys_mman
  ../libc/include/sys/mman.yaml
  sys/mman.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_mman_macros
    .llvm-libc-types.off_t
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
)

add_header_macro(
  sys_prctl
  ../libc/include/sys/prctl.yaml
  sys/prctl.h
  DEPENDS
    .llvm_libc_common_h
)

add_header(
  sys_queue
  HDR
    sys/queue.h
  DEPENDS
    .llvm-libc-macros.sys_queue_macros
)

add_header_macro(
  sys_random
  ../libc/include/sys/random.yaml
  sys/random.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_random_macros
    .llvm-libc-types.size_t
    .llvm-libc-types.ssize_t
)

add_header_macro(
  sys_resource
  ../libc/include/sys/resource.yaml
  sys/resource.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_resource_macros
    .llvm-libc-types.rlim_t
    .llvm-libc-types.struct_rlimit
)

add_header_macro(
  sys_stat
  ../libc/include/sys/stat.yaml
  sys/stat.h
  DEPENDS
    .llvm_libc_common_h
    .llvm-libc-macros.sys_stat_macros
    .llvm-libc-types.mode_t
    .llvm-libc-types.dev_t
    .llvm-libc-types.ino_t
    .llvm-libc-types.nlink_t
    .llvm-libc-types.uid_t
    .llvm-libc-types.gid_t
    .llvm-libc-types.off_t
    .llvm-libc-types.struct_timespec
    .llvm-libc-types.struct_timeval
    .llvm-libc-types.blksize_t
    .llvm-libc-types.blkcnt_t
    .llvm-libc-types.struct_stat
)

add_header_macro(
  sys_select
  ../libc/include/sys/select.yaml
  sys/select.h
  DEPENDS

=== libunwind/src/CMakeLists.txt ===
# Get sources

set(LIBUNWIND_CXX_SOURCES
    libunwind.cpp
    Unwind-EHABI.cpp
    Unwind-seh.cpp
    )

if("${CMAKE_SYSTEM_NAME}" MATCHES "AIX")
  list(APPEND LIBUNWIND_CXX_SOURCES
    Unwind_AIXExtras.cpp
    )
endif()

set(LIBUNWIND_C_SOURCES
    UnwindLevel1.c
    UnwindLevel1-gcc-ext.c
    Unwind-sjlj.c
    Unwind-wasm.c
    )
set_source_files_properties(${LIBUNWIND_C_SOURCES}
                            PROPERTIES
                              # We need to set `-fexceptions` here so that key
                              # unwinding functions, like
                              # _UNWIND_RaiseException, are not marked as
                              # `nounwind`, which breaks LTO builds of
                              # libunwind.  See #56825 and #120657 for context.
                              COMPILE_FLAGS "-std=c99 -fexceptions")

set(LIBUNWIND_ASM_SOURCES
    UnwindRegistersRestore.S
    UnwindRegistersSave.S
    )

set(LIBUNWIND_HEADERS
    AddressSpace.hpp
    assembly.h
    CompactUnwinder.hpp
    config.h
    dwarf2.h
    DwarfInstructions.hpp
    DwarfParser.hpp
    EHHeaderParser.hpp
    FrameHeaderCache.hpp
    libunwind_ext.h
    Registers.hpp
    RWMutex.hpp
    shadow_stack_unwind.h
    Unwind-EHABI.h
    UnwindCursor.hpp
    ../include/libunwind.h
    ../include/unwind.h
    ../include/unwind_itanium.h
    ../include/unwind_arm_ehabi.h
    )
if(APPLE)
  list(APPEND LIBUNWIND_HEADERS
    ../include/mach-o/compact_unwind_encoding.h
    )
endif()

if (MSVC_IDE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  source_group("Header Files" FILES ${LIBUNWIND_HEADERS})
endif()

set(LIBUNWIND_SOURCES
    ${LIBUNWIND_CXX_SOURCES}
    ${LIBUNWIND_C_SOURCES}
    ${LIBUNWIND_ASM_SOURCES})

# Generate library list.
if (NOT APPLE)
  add_library_flags_if(LIBUNWIND_HAS_DL_LIB dl)
endif()

if (LIBUNWIND_ENABLE_THREADS AND NOT APPLE)
    add_library_flags_if(LIBUNWIND_HAS_PTHREAD_LIB pthread)
endif()

if (LIBUNWIND_ENABLE_THREADS)
  add_compile_flags_if(LIBUNWIND_WEAK_PTHREAD_LIB -DLIBUNWIND_USE_WEAK_PTHREAD=1)
endif()

# Setup flags.
add_link_flags_if(CXX_SUPPORTS_UNWINDLIB_EQ_NONE_FLAG --unwindlib=none)

# MINGW_LIBRARIES is defined in config-ix.cmake
add_library_flags_if(MINGW "${MINGW_LIBRARIES}")

if (LIBUNWIND_ENABLE_SHARED AND
    NOT (CXX_SUPPORTS_FNO_EXCEPTIONS_FLAG AND
         CXX_SUPPORTS_FUNWIND_TABLES_FLAG))
  message(FATAL_ERROR
          "Compiler doesn't support generation of unwind tables if exception "
          "support is disabled.  Building libunwind DSO with runtime dependency "
          "on C++ ABI library is not supported.")
endif()

if (HAIKU)
  add_library_flags_if(LIBUNWIND_HAS_ROOT_LIB root)

  add_library_flags_if(LIBUNWIND_HAS_BSD_LIB bsd)
  add_compile_flags_if(LIBUNWIND_HAS_BSD_LIB -D_LIBUNWIND_USE_HAIKU_BSD_LIB=1)

  add_compile_flags("-D_DEFAULT_SOURCE")
  add_compile_flags("-DPT_GNU_EH_FRAME=PT_EH_FRAME")
endif ()

string(REPLACE ";" " " LIBUNWIND_COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_CXX_FLAGS "${LIBUNWIND_CXX_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_C_FLAGS "${LIBUNWIND_C_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}")

set_property(SOURCE ${LIBUNWIND_CXX_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_CXX_FLAGS}")
set_property(SOURCE ${LIBUNWIND_C_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS " ${LIBUNWIND_C_FLAGS}")

# NOTE: avoid implicit dependencies on C++ runtimes.  libunwind uses C++ for
# ease, but does not rely on C++ at runtime.
set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")

include(WarningFlags)

# Build the shared library.
add_library(unwind_shared_objects OBJECT EXCLUDE_FROM_ALL ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
cxx_add_warning_flags(unwind_shared_objects ${LIBUNWIND_ENABLE_WERROR} ${LIBUNWIND_ENABLE_PEDANTIC})
if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
  target_compile_options(unwind_shared_objects PRIVATE /GR-)
else()
  target_compile_options(unwind_shared_objects PRIVATE -fno-rtti)
endif()
target_compile_options(unwind_shared_objects PUBLIC "${LIBUNWIND_ADDITIONAL_COMPILE_FLAGS}")
target_link_libraries(unwind_shared_objects
  PUBLIC "${LIBUNWIND_ADDITIONAL_LIBRARIES}"
  PRIVATE unwind-headers runtimes-libc-headers ${LIBUNWIND_LIBRARIES})
set_target_properties(unwind_shared_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
)
if (CMAKE_POSITION_INDEPENDENT_CODE OR NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set_target_properties(unwind_shared_objects PROPERTIES POSITION_INDEPENDENT_CODE ON) # must set manually because it's an object library
endif()

add_library(unwind_shared SHARED)
target_link_libraries(unwind_shared PUBLIC unwind_shared_objects runtimes-libc-shared)
set_target_properties(unwind_shared
  PROPERTIES
    EXCLUDE_FROM_ALL "$<IF:$<BOOL:${LIBUNWIND_ENABLE_SHARED}>,FALSE,TRUE>"
    LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
    LINKER_LANGUAGE C
    OUTPUT_NAME "${LIBUNWIND_SHARED_OUTPUT_NAME}"
    VERSION     "${LIBUNWIND_LIBRARY_VERSION}"
    SOVERSION   "1"
)

# Build the static library.
add_library(unwind_static_objects OBJECT EXCLUDE_FROM_ALL ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
cxx_add_warning_flags(unwind_static_objects ${LIBUNWIND_ENABLE_WERROR} ${LIBUNWIND_ENABLE_PEDANTIC})
if(CMAKE_C_COMPILER_ID STREQUAL MSVC)
  target_compile_options(unwind_static_objects PRIVATE /GR-)
else()
  target_compile_options(unwind_static_objects PRIVATE -fno-rtti)
endif()
target_compile_options(unwind_static_objects PUBLIC "${LIBUNWIND_ADDITIONAL_COMPILE_FLAGS}")
target_link_libraries(unwind_static_objects
  PUBLIC "${LIBUNWIND_ADDITIONAL_LIBRARIES}"
  PRIVATE unwind-headers runtimes-libc-headers ${LIBUNWIND_LIBRARIES})
set_target_properties(unwind_static_objects
  PROPERTIES
    CXX_EXTENSIONS OFF
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}"
)

if(LIBUNWIND_HIDE_SYMBOLS)
  target_add_compile_flags_if_supported(unwind_static_objects PRIVATE -fvisibility=hidden)
  target_add_compile_flags_if_supported(unwind_static_objects PRIVATE -fvisibility-global-new-delete=force-hidden)
  if (NOT CXX_SUPPORTS_FVISIBILITY_GLOBAL_NEW_DELETE_EQ_FORCE_HIDDEN_FLAG)
    target_add_compile_flags_if_supported(unwind_static_objects PRIVATE -fvisibility-global-new-delete-hidden)
  endif()
  target_compile_definitions(unwind_static_objects PRIVATE _LIBUNWIND_HIDE_SYMBOLS)
endif()

add_library(unwind_static STATIC)
target_link_libraries(unwind_static PUBLIC unwind_static_objects runtimes-libc-static)
set_target_properties(unwind_static
  PROPERTIES
    EXCLUDE_FROM_ALL "$<IF:$<BOOL:${LIBUNWIND_ENABLE_STATIC}>,FALSE,TRUE>"
    LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}"
    LINKER_LANGUAGE C
    OUTPUT_NAME "${LIBUNWIND_STATIC_OUTPUT_NAME}"
)

# Add a meta-target for both libraries.
add_custom_target(unwind)
if (LIBUNWIND_ENABLE_SHARED)
  add_dependencies(unwind unwind_shared)
endif()
if (LIBUNWIND_ENABLE_STATIC)
  add_dependencies(unwind unwind_static)
endif()

if (LIBUNWIND_INSTALL_SHARED_LIBRARY)
  install(TARGETS unwind_shared
    ARCHIVE DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    LIBRARY DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    RUNTIME DESTINATION ${LIBUNWIND_INSTALL_RUNTIME_DIR} COMPONENT unwind)
endif()

if (LIBUNWIND_INSTALL_STATIC_LIBRARY)
  install(TARGETS unwind_static
    ARCHIVE DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    LIBRARY DESTINATION ${LIBUNWIND_INSTALL_LIBRARY_DIR} COMPONENT unwind
    RUNTIME DESTINATION ${LIBUNWIND_INSTALL_RUNTIME_DIR} COMPONENT unwind)
endif()

if (NOT CMAKE_CONFIGURATION_TYPES)
  add_custom_target(install-unwind
    COMMAND "${CMAKE_COMMAND}" --install "${CMAKE_BINARY_DIR}" --component unwind)
  add_custom_target(install-unwind-stripped
    COMMAND "${CMAKE_COMMAND}" --install "${CMAKE_BINARY_DIR}" --component unwind --strip)

  if (LIBUNWIND_INSTALL_LIBRARY)
    add_dependencies(install-unwind unwind)
    add_dependencies(install-unwind-stripped unwind)
  endif()

  if(LIBUNWIND_INSTALL_HEADERS)
    add_dependencies(install-unwind install-unwind-headers)
    add_dependencies(install-unwind-stripped install-unwind-headers-stripped)
  endif()
endif()

=== mlir/python/CMakeLists.txt ===
include(AddMLIRPython)

# Specifies that all MLIR packages are co-located under the `MLIR_PYTHON_PACKAGE_PREFIX.`
# top level package (the API has been embedded in a relocatable way).
add_compile_definitions("MLIR_PYTHON_PACKAGE_PREFIX=${MLIR_PYTHON_PACKAGE_PREFIX}.")

################################################################################
# Structural groupings.
################################################################################

declare_mlir_python_sources(MLIRPythonSources)
declare_mlir_python_sources(MLIRPythonSources.Dialects
  ADD_TO_PARENT MLIRPythonSources)
declare_mlir_python_sources(MLIRPythonSources.Core
  ADD_TO_PARENT MLIRPythonSources)

################################################################################
# Pure python sources and generated code
################################################################################

declare_mlir_python_sources(MLIRPythonSources.Core.Python
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources.Core
  SOURCES
    _mlir_libs/__init__.py
    _mlir_libs/_mlir/py.typed
    ir.py
    passmanager.py
    rewrite.py
    dialects/_ods_common.py
)

declare_mlir_python_sources(MLIRPythonSources.Core.Python.Extras
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources.Core.Python
  SOURCES
    extras/types.py
    extras/meta.py
)

declare_mlir_python_sources(MLIRPythonSources.ExecutionEngine
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  ADD_TO_PARENT MLIRPythonSources
  SOURCES
    execution_engine.py
    _mlir_libs/_mlirExecutionEngine.pyi
  SOURCES_GLOB
    runtime/*.py
)

declare_mlir_python_sources(MLIRPythonCAPI.HeaderSources
  ROOT_DIR "${MLIR_SOURCE_DIR}/include"
  SOURCES_GLOB "mlir-c/*.h"
)

################################################################################
# Dialect bindings
################################################################################

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AffineOps.td
  SOURCES
    dialects/affine.py
  DIALECT_NAME affine
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AMDGPUOps.td
  SOURCES
    dialects/amdgpu.py
  DIALECT_NAME amdgpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/AsyncOps.td
  SOURCES_GLOB dialects/async_dialect/*.py
  DIALECT_NAME async)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BufferizationOps.td
  SOURCES
    dialects/bufferization.py
  DIALECT_NAME bufferization
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Bufferization/IR/BufferizationEnums.td"
)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BuiltinOps.td
  SOURCES
    dialects/builtin.py
  DIALECT_NAME builtin)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ComplexOps.td
  SOURCES
    dialects/complex.py
  DIALECT_NAME complex)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/IndexOps.td
  SOURCES
    dialects/index.py
  DIALECT_NAME index
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ControlFlowOps.td
  SOURCES
    dialects/cf.py
  DIALECT_NAME cf)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/FuncOps.td
  SOURCES
    dialects/func.py
  DIALECT_NAME func)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/OpenACCOps.td
  SOURCES
    dialects/openacc.py
  DIALECT_NAME acc
  DEPENDS acc_common_td
  )

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/GPUOps.td
  SOURCES_GLOB dialects/gpu/*.py
  DIALECT_NAME gpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LinalgOps.td
  SOURCES
  SOURCES_GLOB
    dialects/linalg/*.py
  DIALECT_NAME linalg
  DEPENDS LinalgOdsGen
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LLVMOps.td
  SOURCES
    dialects/llvm.py
  DIALECT_NAME llvm
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformPDLExtensionOps.td
  SOURCES
    dialects/transform/pdl.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_pdl_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformSMTExtensionOps.td
  SOURCES
    dialects/transform/smt.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_smt_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformDebugExtensionOps.td
  SOURCES
    dialects/transform/debug.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_debug_extension)

declare_mlir_dialect_extension_python_bindings(
ADD_TO_PARENT MLIRPythonSources.Dialects
ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformTuneExtensionOps.td
  SOURCES
    dialects/transform/tune.py
  DIALECT_NAME transform
  EXTENSION_NAME transform_tune_extension)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TransformOps.td
  SOURCES
    dialects/transform/__init__.py
    _mlir_libs/_mlir/dialects/transform/__init__.pyi
  DIALECT_NAME transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Transform/IR/TransformAttrs.td"
)

declare_mlir_python_sources(
  MLIRPythonSources.Dialects.transform.extras
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  GEN_ENUM_BINDINGS
  SOURCES
    dialects/transform/extras/__init__.py)

declare_mlir_python_sources(
  MLIRPythonSources.Dialects.transform.interpreter
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  SOURCES
    dialects/transform/interpreter/__init__.py)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/BufferizationTransformOps.td
  SOURCES
    dialects/transform/bufferization.py
  DIALECT_NAME transform
  EXTENSION_NAME bufferization_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/GPUTransformOps.td
  SOURCES
    dialects/transform/gpu.py
  DIALECT_NAME transform
  EXTENSION_NAME gpu_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/SCFLoopTransformOps.td
  SOURCES
    dialects/transform/loop.py
  DIALECT_NAME transform
  EXTENSION_NAME loop_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MemRefTransformOps.td
  SOURCES
    dialects/transform/memref.py
  DIALECT_NAME transform
  EXTENSION_NAME memref_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVGPUTransformOps.td
  SOURCES
    dialects/transform/nvgpu.py
  DIALECT_NAME transform
  EXTENSION_NAME nvgpu_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/LinalgStructuredTransformOps.td
  SOURCES
    dialects/transform/structured.py
  DIALECT_NAME transform
  EXTENSION_NAME structured_transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Linalg/TransformOps/LinalgTransformEnums.td"
)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/SparseTensorTransformOps.td
  SOURCES
    dialects/transform/sparse_tensor.py
  DIALECT_NAME transform
  EXTENSION_NAME sparse_tensor_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/TensorTransformOps.td
  SOURCES
    dialects/transform/tensor.py
  DIALECT_NAME transform
  EXTENSION_NAME tensor_transform)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/VectorTransformOps.td
  SOURCES
    dialects/transform/vector.py
  DIALECT_NAME transform
  EXTENSION_NAME vector_transform
  GEN_ENUM_BINDINGS_TD_FILE
    "../../include/mlir/Dialect/Vector/Transforms/VectorTransformsBase.td"
)

declare_mlir_dialect_extension_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/XeGPUTransformOps.td
  SOURCES
    dialects/transform/xegpu.py
  DIALECT_NAME transform
  EXTENSION_NAME xegpu_transform)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MathOps.td
  SOURCES dialects/math.py
  DIALECT_NAME math)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ArithOps.td
  SOURCES
    dialects/arith.py
  DIALECT_NAME arith
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MemRefOps.td
  SOURCES
    dialects/memref.py
  DIALECT_NAME memref)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ShardOps.td
  SOURCES
    dialects/shard.py
  DIALECT_NAME shard
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/MLProgramOps.td
  SOURCES
    dialects/ml_program.py
  DIALECT_NAME ml_program)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVGPUOps.td
  SOURCES
    dialects/nvgpu.py
  DIALECT_NAME nvgpu
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/NVVMOps.td
  SOURCES
    dialects/nvvm.py
  DIALECT_NAME nvvm
  GEN_ENUM_BINDINGS)

declare_mlir_dialect_python_bindings(
  ADD_TO_PARENT MLIRPythonSources.Dialects
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/mlir"
  TD_FILE dialects/ROCDLOps.td
  SOURCES
    dialects/rocdl.py
  DIALECT_NAME rocdl)

declare_mlir_python_sources(
  MLIRPythonSources.Dialects.quant

=== libc/hdr/types/CMakeLists.txt ===
add_proxy_header_library(
  char8_t
  HDRS
    char8_t.h
  DEPENDS
    libc.hdr.uchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.char8_t
    libc.include.uchar
)

add_proxy_header_library(
  char32_t
  HDRS
    char32_t.h
  DEPENDS
    libc.hdr.uchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.char32_t
    libc.include.uchar
)

add_proxy_header_library(
  mbstate_t
  HDRS
    mbstate_t.h
  DEPENDS
    libc.include.llvm-libc-types.mbstate_t
  FULL_BUILD_DEPENDS
    libc.include.uchar
)

add_proxy_header_library(
  div_t
  HDRS
    div_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.div_t
    libc.include.stdlib
)

add_proxy_header_library(
  struct_dl_phdr_info
  HDRS
    struct_dl_phdr_info.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_dl_phdr_info
)

add_proxy_header_library(
  ldiv_t
  HDRS
    ldiv_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ldiv_t
    libc.include.stdlib
)

add_proxy_header_library(
  lldiv_t
  HDRS
    lldiv_t.h
  DEPENDS
    libc.hdr.stdlib_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.lldiv_t
    libc.include.stdlib
)

add_proxy_header_library(
  sigset_t
  HDRS
    sigset_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.sigset_t
)

add_proxy_header_library(
  struct_epoll_event
  HDRS
    struct_epoll_event.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_epoll_event
)

add_proxy_header_library(
  struct_flock
  HDRS
    struct_flock.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.hdr.stdint_proxy
    libc.include.llvm-libc-types.struct_flock
)

add_proxy_header_library(
  struct_flock64
  HDRS
    struct_flock64.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.hdr.stdint_proxy
    libc.include.llvm-libc-types.struct_flock64
)

add_proxy_header_library(
  struct_f_owner_ex
  HDRS
    struct_f_owner_ex.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_f_owner_ex
)

add_proxy_header_library(
  struct_timespec
  HDRS
    struct_timespec.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_timespec
)

add_proxy_header_library(
  struct_tm
  HDRS
    struct_tm.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_tm
)

add_proxy_header_library(
  size_t
  HDRS
    size_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.size_t
)

add_proxy_header_library(
  ssize_t
  HDRS
    ssize_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ssize_t
)

add_proxy_header_library(
  mode_t
  HDRS
    mode_t.h
  DEPENDS
    libc.hdr.fcntl_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.mode_t
    libc.include.fcntl
)

add_proxy_header_library(
  fenv_t
  HDRS
    fenv_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.fenv_t
    libc.include.fenv
)

add_proxy_header_library(
  fexcept_t
  HDRS
    fexcept_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.fexcept_t
    libc.include.fenv
)

add_proxy_header_library(
  time_t
  HDRS
    time_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.time_t
    libc.include.time
)

add_proxy_header_library(
  clockid_t
  HDRS
    clockid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.clockid_t
)

add_proxy_header_library(
  clock_t
  HDRS
    clock_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.clock_t
    libc.include.time
)

add_proxy_header_library(
  suseconds_t
  HDRS
    suseconds_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.suseconds_t
    libc.include.sys_time
)

add_proxy_header_library(
  struct_timeval
  HDRS
    struct_timeval.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_timeval
    libc.include.sys_time
)

add_proxy_header_library(
  struct_itimerval
  HDRS
    struct_itimerval.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_itimerval
    libc.include.sys_time
)

add_proxy_header_library(
  pid_t
  HDRS
    pid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pid_t
)

add_proxy_header_library(
  pthread_barrier_t
  HDRS
    pthread_barrier_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pthread_barrier_t
)

add_proxy_header_library(
  pthread_barrierattr_t
  HDRS
    pthread_barrierattr_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.pthread_barrierattr_t
)

add_proxy_header_library(
  atexithandler_t
  HDRS
    atexithandler_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.atexithandler_t
    libc.include.stdlib
)

add_proxy_header_library(
  struct_sigaction
  HDRS
    struct_sigaction.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sigaction
    libc.include.signal
)

add_proxy_header_library(
  FILE
  HDRS
    FILE.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.FILE
    libc.include.stdio
)

add_proxy_header_library(
  off_t
  HDRS
    off_t.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.off_t
    libc.include.stdio
)

add_proxy_header_library(
  cookie_io_functions_t
  HDRS
    cookie_io_functions_t.h
  DEPENDS
    libc.hdr.stdio_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.cookie_io_functions_t
    libc.include.stdio
)

add_proxy_header_library(
  locale_t
  HDRS
    locale_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.locale_t
    libc.include.locale
)

add_proxy_header_library(
  stack_t
  HDRS
    stack_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.stack_t
    libc.include.signal
)

add_proxy_header_library(
  jmp_buf
  HDRS
    jmp_buf.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.jmp_buf
    libc.include.setjmp
)

add_proxy_header_library(
  sigjmp_buf
  HDRS
    sigjmp_buf.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.sigjmp_buf
    libc.include.setjmp
)

add_proxy_header_library(
  struct_msghdr
  HDRS
    struct_msghdr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_msghdr
    libc.include.sys_socket
)

add_proxy_header_library(
  struct_sockaddr
  HDRS
    struct_sockaddr.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sockaddr
    libc.include.sys_socket
)

add_proxy_header_library(
  socklen_t
  HDRS
    socklen_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.socklen_t
    libc.include.sys_socket
)

add_proxy_header_library(
  wchar_t
  HDRS
    wchar_t.h
  DEPENDS
    libc.hdr.wchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.wchar_t
    libc.include.wchar
)

add_proxy_header_library(
  wint_t
  HDRS
    wint_t.h
  DEPENDS
    libc.hdr.wchar_overlay
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.wint_t
    libc.include.wchar
)

add_proxy_header_library(
  uid_t
  HDRS
    uid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.uid_t
)

add_proxy_header_library(
  struct_iovec
  HDRS
    struct_iovec.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_iovec
    libc.include.sys_uio
)

add_proxy_header_library(
  nfds_t
  HDRS
    nfds_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.nfds_t
)

add_proxy_header_library(
  struct_pollfd
  HDRS
    struct_pollfd.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_pollfd
)

add_proxy_header_library(
  cpu_set_t
  HDRS
    cpu_set_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.cpu_set_t
    libc.include.sched
)

add_proxy_header_library(
  ENTRY
  HDRS
    ENTRY.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ENTRY
    libc.include.search
)

add_proxy_header_library(
  ACTION
  HDRS
    ACTION.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.ACTION
    libc.include.search
)

add_proxy_header_library(
  struct_sched_param
  HDRS
    struct_sched_param.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_sched_param
    libc.include.sched
)

add_proxy_header_library(
  dl_info
  HDRS
    dl_info.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.dl_info
    libc.include.dlfcn
)

add_proxy_header_library(
  struct_rlimit
  HDRS
    struct_rlimit.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.struct_rlimit
    libc.include.sys_resource
)

add_proxy_header_library(
  gid_t
  HDRS
    gid_t.h
  FULL_BUILD_DEPENDS
    libc.include.llvm-libc-types.gid_t
)

=== libc/src/__support/CMakeLists.txt ===
add_subdirectory(CPP)
add_subdirectory(macros)

add_header_library(
  libc_errno
  HDRS
    libc_errno.h
  DEPENDS
    libc.hdr.errno_macros
    libc.src.__support.macros.config
)

add_header_library(
  block
  HDRS
    block.h
  DEPENDS
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.algorithm
    libc.src.__support.CPP.limits
    libc.src.__support.CPP.new
    libc.src.__support.CPP.optional
    libc.src.__support.CPP.span
    libc.src.__support.CPP.type_traits
    libc.src.__support.math_extras
)

add_object_library(
  freelist
  HDRS
    freelist.h
  SRCS
    freelist.cpp
  DEPENDS
    .block
    libc.src.__support.fixedvector
    libc.src.__support.CPP.array
    libc.src.__support.CPP.cstddef
    libc.src.__support.CPP.new
    libc.src.__support.CPP.span
)

add_object_library(
  freetrie
  HDRS
    freetrie.h
  SRCS
    freetrie.cpp
  DEPENDS
    .block
    .freelist
)

add_header_library(
  freestore
  HDRS
    freestore.h
  DEPENDS
    .freetrie
)

add_object_library(
  freelist_heap
  SRCS
    freelist_heap.cpp
  HDRS
    freelist_heap.h
  COMPILE_OPTIONS
    -DLIBC_FREELIST_MALLOC_SIZE=${LIBC_CONF_FREELIST_MALLOC_BUFFER_SIZE}
  DEPENDS
    .block
    .freelist
    .freestore
    .freetrie
    libc.src.__support.CPP.cstddef
    libc.src.__support.CPP.array
    libc.src.__support.CPP.optional
    libc.src.__support.CPP.span
    libc.src.__support.libc_assert
    libc.src.string.memory_utils.inline_memcpy
    libc.src.string.memory_utils.inline_memset
)

add_header_library(
  blockstore
  HDRS
    blockstore.h
  DEPENDS
    .libc_assert
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.new
)

add_header_library(
  common
  HDRS
    common.h
    endian_internal.h
    macros/properties/architectures.h
    macros/properties/compiler.h
    macros/attributes.h
    macros/config.h
  DEPENDS
    libc.hdr.stdint_proxy
)

add_header_library(
  bit
  HDRS
    bit.h
  DEPENDS
    libc.src.__support.macros.attributes
    libc.src.__support.CPP.type_traits
)

add_header_library(
  math_extras
  HDRS
    math_extras.h
  DEPENDS
    libc.src.__support.CPP.bit
    libc.src.__support.CPP.limits
    libc.src.__support.CPP.type_traits
    libc.src.__support.macros.attributes
    libc.src.__support.macros.config
)

add_header_library(
  sign
  HDRS
    sign.h
  DEPENDS
    libc.src.__support.macros.attributes
)

add_header_library(
  error_or
  HDRS
    error_or.h
  DEPENDS
    libc.src.__support.CPP.expected
)

add_header_library(
  c_string
  HDRS
    c_string.h
  DEPENDS
    libc.src.__support.common
    libc.src.__support.CPP.string
)

add_header_library(
  ctype_utils
  HDRS
    ctype_utils.h
)

add_header_library(
  wctype_utils
  HDRS
    wctype_utils.h
  DEPENDS
    libc.hdr.types.wchar_t
)

add_header_library(
  str_to_num_result
  HDRS
    str_to_num_result.h
  DEPENDS
    libc.src.__support.macros.attributes
)

add_header_library(
  str_to_integer
  HDRS
    str_to_integer.h
  DEPENDS
    .ctype_utils
    .str_to_num_result
    .wctype_utils
    libc.hdr.errno_macros
    libc.src.__support.CPP.limits
    libc.src.__support.CPP.type_traits
    libc.src.__support.common
)

add_header_library(
  integer_to_string
  HDRS
    integer_to_string.h
  DEPENDS
    .big_int
    libc.hdr.stdint_proxy
    libc.src.__support.common
    libc.src.__support.CPP.algorithm
    libc.src.__support.CPP.limits
    libc.src.__support.CPP.span
    libc.src.__support.CPP.string_view
    libc.src.__support.CPP.type_traits
)

add_header_library(
  float_to_string
  HDRS
    float_to_string.h
    ryu_constants.h
    ryu_long_double_constants.h
  DEPENDS
    .libc_assert
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.type_traits
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.common
)

add_header_library(
  high_precision_decimal
  HDRS
    high_precision_decimal.h
  DEPENDS
    .ctype_utils
    .str_to_integer
    .wctype_utils
    libc.hdr.stdint_proxy
)

add_header_library(
  str_to_float
  HDRS
    str_to_float.h
    detailed_powers_of_ten.h
  DEPENDS
    .ctype_utils
    .high_precision_decimal
    .str_to_integer
    .str_to_num_result
    .uint128
    .wctype_utils
    libc.hdr.errno_macros
    libc.hdr.stdint_proxy
    libc.src.__support.common
    libc.src.__support.CPP.bit
    libc.src.__support.CPP.limits
    libc.src.__support.CPP.optional
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.config
    libc.src.__support.macros.null_check
    libc.src.__support.macros.optimization
)

add_header_library(
  integer_literals
  HDRS
    integer_literals.h
  DEPENDS
    .uint128
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.limits
)

add_header_library(
  complex_type
  HDRS
    complex_type.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.macros.properties.complex_types
)

add_header_library(
  complex_basic_ops
  HDRS
    complex_basic_ops.h
  DEPENDS
    .complex_type
    libc.src.__support.CPP.bit
    libc.src.__support.FPUtil.fp_bits
)

add_header_library(
  integer_operations
  HDRS
    integer_operations.h
)

add_header_library(
  arg_list
  HDRS
    arg_list.h
  DEPENDS
    libc.hdr.stdint_proxy
    libc.src.__support.common
    libc.src.string.memory_utils.inline_memcpy
)

add_header_library(
  fixedvector
  HDRS
    fixedvector.h
  DEPENDS
    .libc_assert
    libc.src.__support.CPP.array
    libc.src.string.memory_utils.inline_memset
)

add_header_library(
  char_vector
  HDRS
    char_vector.h
  DEPENDS
    libc.hdr.func.free
    libc.hdr.func.malloc
    libc.hdr.func.realloc
    libc.src.__support.common
)

add_header_library(
  number_pair
  HDRS
    number_pair.h
  DEPENDS
    libc.src.__support.CPP.type_traits
)

add_header_library(
  big_int
  HDRS
    big_int.h
  DEPENDS
    .math_extras
    .number_pair
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.array
    libc.src.__support.CPP.bit
    libc.src.__support.CPP.type_traits
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_header_library(
  uint128
  HDRS
    uint128.h
  DEPENDS
    .big_int
    libc.src.__support.macros.properties.types
)

add_header_library(
  libc_assert
  HDRS
    libc_assert.h
  DEPENDS
    .integer_to_string
    libc.src.__support.OSUtil.osutil
    libc.src.__support.macros.optimization
)

add_header_library(
  hash
  HDRS
    hash.h
  DEPENDS
    .uint128
    libc.hdr.stdint_proxy
    libc.src.__support.CPP.bit
    libc.src.__support.CPP.limits
    libc.src.__support.macros.attributes
)

add_header_library(
  memory_size
  HDRS
    memory_size.h
  DEPENDS
    libc.src.__support.CPP.type_traits
    libc.src.__support.CPP.limits
    libc.src.__support.macros.optimization
    libc.src.__support.macros.attributes
    libc.src.__support.macros.config
)

add_header_library(
  intrusive_list
  HDRS
    intrusive_list.h
  DEPENDS
    libc.src.__support.macros.attributes
)

add_subdirectory(FPUtil)
add_subdirectory(OSUtil)
add_subdirectory(StringUtil)
add_subdirectory(GPU)
add_subdirectory(RPC)

# Thread support is used by other "File". So, we add the "threads"
# before "File".
add_subdirectory(threads)

add_subdirectory(File)

add_subdirectory(HashTable)

add_subdirectory(fixed_point)

add_subdirectory(time)

# Requires access to uchar header which is not on macos
# Therefore, cannot currently build this on macos in overlay mode
if(NOT (LIBC_TARGET_OS_IS_DARWIN))
  add_subdirectory(wchar)
endif()

add_subdirectory(math)

=== libc/src/wchar/CMakeLists.txt ===
add_header_library(
  wchar_utils
  HDRS
    wchar_utils.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
    libc.src.__support.common
)

add_entrypoint_object(
  wcslen
  SRCS
    wcslen.cpp
  HDRS
    wcslen.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcsnlen
  SRCS
    wcsnlen.cpp
  HDRS
    wcsnlen.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
)

add_entrypoint_object(
  wctob
  SRCS
    wctob.cpp
  HDRS
    wctob.h
  DEPENDS
    libc.hdr.types.wint_t
    libc.hdr.stdio_macros
)

add_entrypoint_object(
  btowc
  SRCS
    btowc.cpp
  HDRS
    btowc.h
  DEPENDS
    libc.hdr.types.wint_t
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wcstol
  SRCS
    wcstol.cpp
  HDRS
    wcstol.h
  DEPENDS
    libc.src.errno.errno
    libc.src.__support.str_to_integer
)

add_entrypoint_object(
  wcstoll
  SRCS
    wcstoll.cpp
  HDRS
    wcstoll.h
  DEPENDS
    libc.src.errno.errno
    libc.src.__support.str_to_integer
)

add_entrypoint_object(
  wcstoul
  SRCS
    wcstoul.cpp
  HDRS
    wcstoul.h
  DEPENDS
    libc.src.errno.errno
    libc.src.__support.str_to_integer
)

add_entrypoint_object(
  wcstoull
  SRCS
    wcstoull.cpp
  HDRS
    wcstoull.h
  DEPENDS
    libc.src.errno.errno
    libc.src.__support.str_to_integer
)

add_entrypoint_object(
  wcstof
  SRCS
    wcstof.cpp
  HDRS
    wcstof.h
  DEPENDS
    libc.src.__support.str_to_float
    libc.src.errno.errno
)

add_entrypoint_object(
  wcstod
  SRCS
    wcstod.cpp
  HDRS
    wcstod.h
  DEPENDS
    libc.src.__support.str_to_float
    libc.src.errno.errno
)

add_entrypoint_object(
  wcstold
  SRCS
    wcstold.cpp
  HDRS
    wcstold.h
  DEPENDS
    libc.src.__support.str_to_float
    libc.src.errno.errno
)

add_entrypoint_object(
  wcstok
  SRCS
    wcstok.cpp
  HDRS
    wcstok.h
  DEPENDS
    libc.hdr.types.wchar_t
)

add_entrypoint_object(
  wcrtomb
  SRCS
    wcrtomb.cpp
  HDRS
    wcrtomb.h
  DEPENDS
    libc.hdr.types.wchar_t
    libc.hdr.types.mbstate_t
    libc.src.__support.libc_errno
    libc.src.__support.wchar.wcrtomb
    libc.src.__support.wchar.mbstate
)

add_entrypoint_object(
  mbsinit
  SRCS
    mbsinit.cpp
  HDRS
    mbsinit.h
  DEPENDS
    libc.hdr.types.wchar_t
    libc.hdr.types.mbstate_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.wchar.character_converter
    libc.src.__support.wchar.mbstate
)

add_entrypoint_object(
  mbrtowc
  SRCS
    mbrtowc.cpp
  HDRS
    mbrtowc.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.mbstate_t
    libc.hdr.types.wchar_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.wchar.mbrtowc
    libc.src.__support.libc_errno
    libc.src.__support.wchar.mbstate
)

add_entrypoint_object(
  mbsrtowcs
  SRCS
    mbsrtowcs.cpp
  HDRS
    mbsrtowcs.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.libc_errno
    libc.src.__support.wchar.mbstate
    libc.src.__support.wchar.mbsnrtowcs
)

add_entrypoint_object(
  mbsnrtowcs
  SRCS
    mbsnrtowcs.cpp
  HDRS
    mbsnrtowcs.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.libc_errno
    libc.src.__support.wchar.mbstate
    libc.src.__support.wchar.mbsnrtowcs
)

add_entrypoint_object(
  wcsrtombs
  SRCS
    wcsrtombs.cpp
  HDRS
    wcsrtombs.h
  DEPENDS
    libc.hdr.types.wchar_t
    libc.hdr.types.mbstate_t
    libc.src.__support.wchar.mbstate
    libc.src.__support.wchar.wcsnrtombs
    libc.src.__support.libc_errno
)

add_entrypoint_object(
  wcsnrtombs
  SRCS
    wcsnrtombs.cpp
  HDRS
    wcsnrtombs.h
  DEPENDS
    libc.hdr.types.wchar_t
    libc.hdr.types.mbstate_t
    libc.src.__support.wchar.mbstate
    libc.src.__support.wchar.wcsnrtombs
    libc.src.__support.libc_errno
)

add_entrypoint_object(
  mblen
  SRCS
    mblen.cpp
  HDRS
    mblen.h
  DEPENDS
    libc.hdr.types.size_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.libc_errno
    libc.src.__support.wchar.mbrtowc
    libc.src.__support.wchar.mbstate
)

add_entrypoint_object(
  mbrlen
  SRCS
    mbrlen.cpp
  HDRS
    mbrlen.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.mbstate_t
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.wchar.mbrtowc
    libc.src.__support.libc_errno
    libc.src.__support.wchar.mbstate
)

add_entrypoint_object(
  wmemset
  SRCS
    wmemset.cpp
  HDRS
    wmemset.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.types.wchar_t
)

add_entrypoint_object(
  wcpcpy
  SRCS
    wcpcpy.cpp
  HDRS
    wcpcpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcpncpy
  SRCS
    wcpncpy.cpp
  HDRS
    wcpncpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.__support.macros.null_check
)   

add_entrypoint_object(
  wcschr
  SRCS
    wcschr.cpp
  HDRS
    wcschr.h
  DEPENDS
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wcscmp
  SRCS
    wcscmp.cpp
  HDRS
    wcscmp.h
  DEPENDS
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wcsdup
  SRCS
    wcsdup.cpp
  HDRS
    wcsdup.h
  DEPENDS
    libc.hdr.types.wchar_t
    libc.src.__support.libc_errno
    libc.src.__support.macros.config
    libc.src.string.allocating_string_utils
)

add_entrypoint_object(
  wcspbrk
  SRCS
    wcspbrk.cpp
  HDRS
    wcspbrk.h
  DEPENDS
    libc.hdr.wchar_macros
    libc.src.__support.macros.null_check
)

add_entrypoint_object(
  wcsrchr
  SRCS
    wcsrchr.cpp
  HDRS
    wcsrchr.h
  DEPENDS
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wcsncmp
  SRCS
    wcsncmp.cpp
  HDRS
    wcsncmp.h
  DEPENDS
    libc.hdr.wchar_macros
    libc.hdr.types.size_t
)

add_entrypoint_object(
  wcsspn
  SRCS
    wcsspn.cpp
  HDRS
    wcsspn.h
  DEPENDS
    libc.hdr.wchar_macros
    libc.hdr.types.size_t
    libc.src.wchar.wchar_utils
    libc.src.__support.macros.null_check
)

add_entrypoint_object(
  wcscspn
  SRCS
    wcscspn.cpp
  HDRS
    wcscspn.h
  DEPENDS
    libc.hdr.wchar_macros
    libc.hdr.types.size_t
    libc.src.wchar.wchar_utils
    libc.src.__support.macros.null_check
)

add_entrypoint_object(
  wmemcmp
  SRCS
    wmemcmp.cpp
  HDRS
    wmemcmp.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.__support.macros.null_check
)

add_entrypoint_object(
  wmemcpy
  SRCS
    wmemcpy.cpp
  HDRS
    wmemcpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.memory_utils.inline_memcpy
)

add_entrypoint_object(
  wmemmove
  SRCS
    wmemmove.cpp
  HDRS
    wmemmove.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.__support.macros.null_check
)

add_entrypoint_object(
  wcsncpy
  SRCS
    wcsncpy.cpp
  HDRS
    wcsncpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcscat
  SRCS
    wcscat.cpp
  HDRS
    wcscat.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcsstr
  SRCS
    wcsstr.cpp
  HDRS
    wcsstr.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcsncat
  SRCS
    wcsncat.cpp
  HDRS
    wcsncat.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcslcat
  SRCS
    wcslcat.cpp
  HDRS
    wcslcat.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wmemchr
  SRCS
    wmemchr.cpp
  HDRS
    wmemchr.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wmempcpy
  SRCS
    wmempcpy.cpp
  HDRS
    wmempcpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
)

add_entrypoint_object(
  wcscpy
  SRCS
    wcscpy.cpp
  HDRS
    wcscpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
    libc.src.string.string_utils
)

add_entrypoint_object(
  wcslcpy
  SRCS
    wcslcpy.cpp
  HDRS
    wcslcpy.h
  DEPENDS
    libc.hdr.types.size_t
    libc.hdr.wchar_macros
)

=== libc/test/IntegrationTest/CMakeLists.txt ===
set(arch_specific_deps)
if(LIBC_TARGET_ARCHITECTURE_IS_AARCH64)
  set(arch_specific_deps libc.src.sys.auxv.getauxval)
endif()
add_object_library(
  test
  SRCS
    test.cpp
  COMPILE_OPTIONS
    ${TEST_COMPILE_FLAGS}
  HDRS
    test.h
  DEPENDS
    libc.hdr.stdint_proxy
    libc.src.__support.OSUtil.osutil
    libc.src.__support.CPP.atomic
    libc.src.__support.macros.properties.architectures
    ${arch_specific_deps}
)

=== libc/test/shared/CMakeLists.txt ===
add_custom_target(libc-shared-tests)

add_fp_unittest(
  shared_math_test
  SUITE
    libc-shared-tests
  SRCS
    shared_math_test.cpp
  DEPENDS
    libc.src.__support.math.acos
    libc.src.__support.math.acosf
    libc.src.__support.math.acosf16
    libc.src.__support.math.acoshf
    libc.src.__support.math.acoshf16
    libc.src.__support.math.acospif16
    libc.src.__support.math.asin
    libc.src.__support.math.asinf
    libc.src.__support.math.asinf16
    libc.src.__support.math.asinhf
    libc.src.__support.math.asinhf16
    libc.src.__support.math.atan
    libc.src.__support.math.atan2
    libc.src.__support.math.atan2f
    libc.src.__support.math.atan2f128
    libc.src.__support.math.atanf
    libc.src.__support.math.atanf16
    libc.src.__support.math.atanhf
    libc.src.__support.math.atanhf16
    libc.src.__support.math.cbrt
    libc.src.__support.math.cbrtf
    libc.src.__support.math.cos
    libc.src.__support.math.cosf
    libc.src.__support.math.cosf16
    libc.src.__support.math.coshf
    libc.src.__support.math.coshf16
    libc.src.__support.math.cospif
    libc.src.__support.math.cospif16
    libc.src.__support.math.dsqrtl
    libc.src.__support.math.exp10m1f
    libc.src.__support.math.exp10m1f16
    libc.src.__support.math.erff
    libc.src.__support.math.exp
    libc.src.__support.math.exp2
    libc.src.__support.math.exp2f
    libc.src.__support.math.exp2f16
    libc.src.__support.math.exp2m1f
    libc.src.__support.math.exp2m1f16
    libc.src.__support.math.expm1
    libc.src.__support.math.expm1f
    libc.src.__support.math.exp10
    libc.src.__support.math.exp10f
    libc.src.__support.math.exp10f16
    libc.src.__support.math.expf
    libc.src.__support.math.expf16
    libc.src.__support.math.frexpf
    libc.src.__support.math.frexpf128
    libc.src.__support.math.frexpf16
    libc.src.__support.math.ldexpf
    libc.src.__support.math.ldexpf128
    libc.src.__support.math.ldexpf16
    libc.src.__support.math.rsqrtf
    libc.src.__support.math.rsqrtf16
)

=== lldb/source/API/CMakeLists.txt ===
get_property(LLDB_ALL_PLUGINS GLOBAL PROPERTY LLDB_PLUGINS)

if(LLDB_BUILD_FRAMEWORK)
  set(option_install_prefix INSTALL_PREFIX ${LLDB_FRAMEWORK_INSTALL_DIR})
  set(option_framework FRAMEWORK)
endif()

if(LLDB_ENABLE_PYTHON)
  if (APPLE AND LLVM_ENABLE_LOCAL_SUBMODULE_VISIBILITY)
    # Work around an issue with the Python headers, which have a modular include
    # inside an extern "C" block.
    remove_module_flags()
  endif()
  get_target_property(python_bindings_dir swig_wrapper_python BINARY_DIR)
  set(lldb_python_wrapper ${python_bindings_dir}/LLDBWrapPython.cpp)
endif()

if(LLDB_ENABLE_LUA)
  get_target_property(lua_bindings_dir swig_wrapper_lua BINARY_DIR)
  set(lldb_lua_wrapper ${lua_bindings_dir}/LLDBWrapLua.cpp)
endif()

# Generate SBLanguages.h from Dwarf.def.
set(sb_languages_file
  ${CMAKE_CURRENT_BINARY_DIR}/../../include/lldb/API/SBLanguages.h)
set(sb_languages_generator
  ${LLDB_SOURCE_DIR}/scripts/generate-sbapi-dwarf-enum.py)
add_custom_command(
  COMMENT "Generating SBLanguages.h from Dwarf.def"
  COMMAND "${Python3_EXECUTABLE}"
      ${sb_languages_generator}
      ${LLVM_MAIN_INCLUDE_DIR}/llvm/BinaryFormat/Dwarf.def
      -o ${sb_languages_file}
  OUTPUT ${sb_languages_file}
  DEPENDS ${LLVM_MAIN_INCLUDE_DIR}/llvm/BinaryFormat/Dwarf.def
          ${sb_languages_generator}
  WORKING_DIRECTORY ${LLVM_LIBRARY_OUTPUT_INTDIR}
)
add_custom_target(lldb-sbapi-dwarf-enums
  DEPENDS ${sb_languages_file})
set_target_properties(lldb-sbapi-dwarf-enums PROPERTIES FOLDER "LLDB/Tablegenning")

add_lldb_library(liblldb SHARED ${option_framework}
  SBAddress.cpp
  SBAddressRange.cpp
  SBAddressRangeList.cpp
  SBAttachInfo.cpp
  SBBlock.cpp
  SBBreakpoint.cpp
  SBBreakpointLocation.cpp
  SBBreakpointName.cpp
  SBBreakpointOptionCommon.cpp
  SBBroadcaster.cpp
  SBCommandInterpreter.cpp
  SBCommandInterpreterRunOptions.cpp
  SBCommandReturnObject.cpp
  SBCommunication.cpp
  SBCompileUnit.cpp
  SBData.cpp
  SBDebugger.cpp
  SBDeclaration.cpp
  SBEnvironment.cpp
  SBError.cpp
  SBEvent.cpp
  SBExecutionContext.cpp
  SBExpressionOptions.cpp
  SBFile.cpp
  SBFileSpec.cpp
  SBFileSpecList.cpp
  SBFormat.cpp
  SBFrame.cpp
  SBFrameList.cpp
  SBFunction.cpp
  SBHostOS.cpp
  SBInstruction.cpp
  SBInstructionList.cpp
  SBLanguageRuntime.cpp
  SBLaunchInfo.cpp
  SBLineEntry.cpp
  SBListener.cpp
  SBMemoryRegionInfo.cpp
  SBMemoryRegionInfoList.cpp
  SBModule.cpp
  SBModuleSpec.cpp
  SBMutex.cpp
  SBPlatform.cpp
  SBProcess.cpp
  SBProcessInfo.cpp
  SBProcessInfoList.cpp
  SBProgress.cpp
  SBQueue.cpp
  SBQueueItem.cpp
  SBReproducer.cpp
  SBSaveCoreOptions.cpp
  SBScriptObject.cpp
  SBSection.cpp
  SBSourceManager.cpp
  SBStatisticsOptions.cpp
  SBStream.cpp
  SBStringList.cpp
  SBStructuredData.cpp
  SBSymbol.cpp
  SBSymbolContext.cpp
  SBSymbolContextList.cpp
  SBTarget.cpp
  SBThread.cpp
  SBThreadCollection.cpp
  SBThreadPlan.cpp
  SBTrace.cpp
  SBTraceCursor.cpp
  SBType.cpp
  SBTypeCategory.cpp
  SBTypeEnumMember.cpp
  SBTypeFilter.cpp
  SBTypeFormat.cpp
  SBTypeNameSpecifier.cpp
  SBTypeSummary.cpp
  SBTypeSynthetic.cpp
  SBUnixSignals.cpp
  SBValue.cpp
  SBValueList.cpp
  SBVariablesOptions.cpp
  SBWatchpoint.cpp
  SBWatchpointOptions.cpp
  SystemInitializerFull.cpp
  ${lldb_python_wrapper}
  ${lldb_lua_wrapper}

  ADDITIONAL_HEADER_DIRS
    ${LLDB_INCLUDE_DIR}/lldb/API
  DEPENDS
    lldb-sbapi-dwarf-enums

  LINK_COMPONENTS
    Support
  LINK_LIBS
    lldbBreakpoint
    lldbCore
    lldbDataFormatters
    lldbExpression
    lldbHost
    lldbInitialization
    lldbInterpreter
    lldbSymbol
    lldbTarget
    lldbUtility
    lldbValueObject
    lldbVersion
    ${LLDB_ALL_PLUGINS}

  ${option_install_prefix}
)

# lib/pythonX.Y/dist-packages/lldb/_lldb.so is a symlink to lib/liblldb.so,
# which depends on lib/libLLVM*.so (BUILD_SHARED_LIBS) or lib/libLLVM-10git.so
# (LLVM_LINK_LLVM_DYLIB). Add an additional rpath $ORIGIN/../../../../lib so
# that _lldb.so can be loaded from Python.
if(LLDB_ENABLE_PYTHON AND (BUILD_SHARED_LIBS OR LLVM_LINK_LLVM_DYLIB) AND UNIX AND NOT APPLE)
  set_property(TARGET liblldb APPEND PROPERTY INSTALL_RPATH "\$ORIGIN/../../../../lib${LLVM_LIBDIR_SUFFIX}")
endif()

if(Python3_RPATH)
  set_property(TARGET liblldb APPEND PROPERTY INSTALL_RPATH "${Python3_RPATH}")
  set_property(TARGET liblldb APPEND PROPERTY BUILD_RPATH   "${Python3_RPATH}")
endif()


if(LLDB_ENABLE_PYTHON)
  add_dependencies(liblldb swig_wrapper_python)

  if (MSVC)
    set_property(SOURCE ${lldb_python_wrapper} APPEND_STRING PROPERTY COMPILE_FLAGS " /W0")
  else()
    set_property(SOURCE ${lldb_python_wrapper} APPEND_STRING PROPERTY COMPILE_FLAGS " -w")
  endif()

  set_source_files_properties(${lldb_python_wrapper} PROPERTIES GENERATED ON)
  if (CLANG_CL)
    set_property(SOURCE ${lldb_python_wrapper} APPEND_STRING
      PROPERTY COMPILE_FLAGS " -Wno-unused-function")
  endif()
  if (LLVM_COMPILER_IS_GCC_COMPATIBLE AND
      NOT "${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    set_property(SOURCE ${lldb_python_wrapper} APPEND_STRING
      PROPERTY COMPILE_FLAGS " -Wno-sequence-point -Wno-cast-qual")
  endif ()
endif()

if(LLDB_ENABLE_LUA)
  add_dependencies(liblldb swig_wrapper_lua)
  target_include_directories(liblldb PRIVATE ${LUA_INCLUDE_DIR})

  if (MSVC)
    set_property(SOURCE ${lldb_lua_wrapper} APPEND_STRING PROPERTY COMPILE_FLAGS " /W0")
  else()
    set_property(SOURCE ${lldb_lua_wrapper} APPEND_STRING PROPERTY COMPILE_FLAGS " -w")
  endif()

  set_source_files_properties(${lldb_lua_wrapper} PROPERTIES GENERATED ON)
endif()

set_target_properties(liblldb
  PROPERTIES
  VERSION ${LLDB_VERSION}
)

target_compile_definitions(liblldb PRIVATE LLDB_IN_LIBLLDB)
if (NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
  if (NOT LLDB_EXPORT_ALL_SYMBOLS)
    # If we're not exporting all symbols, we'll want to explicitly set
    # the exported symbols here.  This prevents 'log enable --stack ...'
    # from working on some systems but limits the liblldb size.
    message(STATUS "Symbols (liblldb): exporting all symbols from the lldb namespace")
    add_llvm_symbol_exports(liblldb ${CMAKE_CURRENT_SOURCE_DIR}/liblldb.exports)
  elseif (NOT LLDB_EXPORT_ALL_SYMBOLS_EXPORTS_FILE)
    # Don't use an explicit export. Instead, tell the linker to export all symbols.
    message(STATUS "Symbols (liblldb): exporting all symbols from the lldb and lldb_private namespaces")
    message(WARNING "Private LLDB symbols frequently change and no API stability is guaranteed. "
                    "Only the SB API is guaranteed to be stable.")
    add_llvm_symbol_exports(liblldb ${CMAKE_CURRENT_SOURCE_DIR}/liblldb-private.exports)
  else ()
    message(STATUS "Symbols (liblldb): exporting all symbols specified in the exports "
            " file '${LLDB_EXPORT_ALL_SYMBOLS_EXPORTS_FILE}'")
    message(WARNING "Private LLDB symbols frequently change and no API stability is guaranteed. "
                    "Only the SB API is guaranteed to be stable.")
    add_llvm_symbol_exports(liblldb "${LLDB_EXPORT_ALL_SYMBOLS_EXPORTS_FILE}")
  endif()
elseif (LLDB_EXPORT_ALL_SYMBOLS)
  message(STATUS "Symbols (liblldb): exporting all symbols from the lldb and lldb_private namespaces")

  # Pull out the various lldb libraries linked into liblldb, these will be used
  # when looking for symbols to extract. We ignore most plugin libraries here,
  # because we may expose more symbols than the DLL limit and these symbols
  # aren't useful to expose.
  get_target_property(all_liblldb_libs liblldb LINK_LIBRARIES)
  set(lldb_libs "")
  foreach(lib ${all_liblldb_libs})
    if(TARGET ${lib} AND ${lib} MATCHES "^lldb" AND
       (${lib} IN_LIST LLDB_EXPORT_ALL_SYMBOLS_PLUGINS OR
        NOT ${lib} MATCHES "^lldbPlugin"))
      get_target_property(lib_type ${lib} TYPE)
      if("${lib_type}" STREQUAL "STATIC_LIBRARY")
        list(APPEND lldb_libs ${lib})
      endif()
    endif()
  endforeach(lib)
  list(REMOVE_DUPLICATES lldb_libs)

  # Extract all of the private symbols and produce a single file we can use for
  # the exports.
  set(exported_symbol_file ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}/liblldb_private.symbols)
  get_host_tool_path(llvm-nm LLVM_NM llvm_nm_exe llvm_nm_target)
  add_custom_command(
    OUTPUT ${exported_symbol_file}
    COMMAND "${Python3_EXECUTABLE}"
      ${LLDB_SOURCE_DIR}/scripts/msvc_extract_private_symbols.py
      ${lldb_libs} -o ${exported_symbol_file} --nm=${llvm_nm_exe}
    WORKING_DIRECTORY ${LLVM_LIBRARY_OUTPUT_INTDIR}
    DEPENDS ${LLDB_SOURCE_DIR}/scripts/msvc_extract_private_symbols.py
      ${lldb_libs} ${llvm_nm_target}
    VERBATIM
    COMMENT "Generating liblldb private export list"
  )

  add_llvm_symbol_exports(liblldb ${exported_symbol_file})
endif()

if (NOT MSVC)
  set_target_properties(liblldb
    PROPERTIES
    OUTPUT_NAME lldb
  )
endif()

# The Clang expression parser in LLDB requires the Clang resource directory to function.
if (TARGET clang-resource-headers)
  # If building alongside Clang, just add a dependency to ensure it is build together with liblldb.
  add_dependencies(liblldb clang-resource-headers)
else()
  # In a standalone build create a symlink from the LLDB library directory that points to the
  # resource directory in the Clang library directory. LLDB searches relative to its install path,
  # and the symlink is created in the same relative path as the resource directory of Clang when
  # building alongside Clang.
  # When building the LLDB framework, this isn't necessary as there we copy everything we need into
  # the framework (including the Clang resourece directory).
  if(NOT LLDB_BUILD_FRAMEWORK)
    set(LLDB_CLANG_RESOURCE_DIR "$<TARGET_FILE_DIR:liblldb>/clang")
    add_custom_command(TARGET liblldb POST_BUILD
      COMMENT "Linking Clang resource dir into LLDB build directory: ${LLDB_CLANG_RESOURCE_DIR}"
      COMMAND ${CMAKE_COMMAND} -E create_symlink
      "${LLDB_EXTERNAL_CLANG_RESOURCE_DIR}" "${LLDB_CLANG_RESOURCE_DIR}"
    )
  endif()
endif()

# Stage all headers in the include directory in the build dir.
file(GLOB public_headers ${LLDB_SOURCE_DIR}/include/lldb/API/*.h)
set(lldb_header_staging_dir ${CMAKE_BINARY_DIR}/include/lldb)
set(generated_public_headers ${LLDB_OBJ_DIR}/include/lldb/API/SBLanguages.h)
file(GLOB root_public_headers ${LLDB_SOURCE_DIR}/include/lldb/lldb-*.h)
file(GLOB root_private_headers ${LLDB_SOURCE_DIR}/include/lldb/lldb-private*.h)
list(REMOVE_ITEM root_public_headers ${root_private_headers})
# Skip the initial copy of lldb-defines.h. The fixed version is generated at build time.
list(REMOVE_ITEM root_public_headers ${LLDB_SOURCE_DIR}/include/lldb/lldb-defines.h)

find_program(unifdef_EXECUTABLE unifdef)

add_custom_target(liblldb-header-staging)

if (LLDB_BUILD_FRAMEWORK)
  add_custom_target(lldb-framework-fixup-all-headers)
  add_dependencies(lldb-framework-fixup-all-headers liblldb-header-staging)
  add_dependencies(liblldb lldb-framework-fixup-all-headers)
endif()

foreach(header
    ${public_headers}
    ${generated_public_headers}
    ${root_public_headers})
  get_filename_component(basename ${header} NAME)
  set(staged_header ${lldb_header_staging_dir}/${basename})

  if(unifdef_EXECUTABLE)
    # unifdef returns 0 when the file is unchanged and 1 if something was changed.
    # That means if we successfully remove SWIG code, the build system believes
    # that the command has failed and stops. This is undesirable.
    set(copy_command ${unifdef_EXECUTABLE} -USWIG ${header} > ${staged_header} || (exit 0))
  else()
    set(copy_command ${CMAKE_COMMAND} -E copy ${header} ${staged_header})
  endif()

  add_custom_target(liblldb-stage-header-${basename} DEPENDS ${staged_header})
  add_dependencies(liblldb-stage-header-${basename} lldb-sbapi-dwarf-enums)
  add_dependencies(liblldb-header-staging liblldb-stage-header-${basename})
  add_custom_command(
    DEPENDS ${header} OUTPUT ${staged_header}
    COMMAND ${copy_command}
    COMMENT "LLDB headers: stage LLDB headers in include directory")

=== libc/src/__support/math/CMakeLists.txt ===
add_header_library(
  acos
  HDRS
    acos.h
  DEPENDS
    .asin_utils
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
    libc.src.__support.macros.properties.cpu_features
)

add_header_library(
  acosf
  HDRS
    acosf.h
  DEPENDS
    .inv_trigf_utils
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
)

add_header_library(
  acosf16
  HDRS
    acosf16.h
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_header_library(
  acosh_float_constants
  HDRS
    acosh_float_constants.h
  DEPENDS
    libc.src.__support.macros.config
)

add_header_library(
  acoshf_utils
  HDRS
    acoshf_utils.h
  DEPENDS
    .acosh_float_constants
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
)

add_header_library(
  acoshf
  HDRS
    acoshf.h
  DEPENDS
    .acoshf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
)

add_header_library(
  acoshf16
  HDRS
    acoshf16.h
  DEPENDS
    .acoshf_utils
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
)

add_header_library(
  acospif16
  HDRS
    acospif16.h
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_header_library(
  asin_utils
  HDRS
    asin_utils.h
  DEPENDS
    libc.src.__support.integer_literals
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
)

add_header_library(
  asin
  HDRS
    asin.h
  DEPENDS
    .asin_utils
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.cpu_features
)

add_header_library(
  asinhf
  HDRS
    asinhf.h
  DEPENDS
    .acoshf_utils
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.config
    libc.src.__support.macros.optimization
)

add_header_library(
  asinhf16
  HDRS
    asinhf16.h
  DEPENDS
    .acoshf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.config
    libc.src.__support.macros.optimization
)

add_header_library(
  atan_utils
  HDRS
    atan_utils.h
  DEPENDS
    libc.src.__support.integer_literals
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
)

add_header_library(
  atan
  HDRS
    atan.h
  DEPENDS
    .atan_utils
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.macros.optimization
)

add_header_library(
  atan2
  HDRS
    atan2.h
  DEPENDS
    .atan_utils
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.macros.optimization
)

add_header_library(
  atan2f
  HDRS
    atan2f_float.h
    atan2f.h
  DEPENDS
    .inv_trigf_utils
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.config
    libc.src.__support.macros.optimization
)

add_header_library(
  atan2f128
  HDRS
    atan2f128.h
  DEPENDS
    .atan_utils
    libc.src.__support.integer_literals
    libc.src.__support.uint128
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.macros.optimization
)

add_header_library(
  atanf
  HDRS
    atanf_float.h
    atanf.h
  DEPENDS
    .inv_trigf_utils
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_header_library(
  atanf16
  HDRS
    atanf16.h
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
)

add_header_library(
  atanhf
  HDRS
    atanhf.h
  DEPENDS
    .acoshf_utils
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.macros.optimization
)

add_header_library(
  atanhf16
  HDRS
    atanhf16.h
  DEPENDS
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.config
    libc.src.__support.macros.optimization
)

add_header_library(
  asinf
  HDRS
    asinf.h
  DEPENDS
    .inv_trigf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.config
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.cpu_features
)

add_header_library(
  asinf16
  HDRS
    asinf16.h
  DEPENDS
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.sqrt
    libc.src.__support.macros.optimization
)

add_header_library(
  cbrt
  HDRS
    cbrt.h
  DEPENDS
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
    libc.src.__support.integer_literals
)

add_header_library(
  cbrtf
  HDRS
    cbrtf.h
  DEPENDS
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_header_library(
  common_constants
  HDRS
    common_constants.h
  DEPENDS
    libc.src.__support.macros.config
    libc.src.__support.number_pair
)

add_header_library(
  cos
  HDRS
    cos.h
  DEPENDS
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.math.range_reduction_double
    libc.src.__support.math.sincos_eval
    libc.src.__support.macros.optimization
)

add_header_library(
  cosf
  HDRS
    cosf.h
  DEPENDS
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
)

add_header_library(
  cosf16
  HDRS
    cosf16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_header_library(
  coshf
  HDRS
    coshf.h
  DEPENDS
    .sinhfcoshf_utils
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_header_library(
  coshf16
  HDRS
    coshf16.h
  DEPENDS
    .expxf16_utils
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_header_library(
  cospif
  HDRS
    cospif.h
  DEPENDS
    .sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_header_library(
  cospif16
  HDRS
    cospif16.h
  DEPENDS
    .sincosf16_utils
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_header_library(
  dsqrtl
  HDRS
    dsqrtl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.sqrt
)

add_header_library(
  exp10m1f
  HDRS
    exp10m1f.h
  DEPENDS
    .exp10f_utils
    libc.src.errno.errno
    libc.src.__support.common
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_header_library(
  exp10m1f16
  HDRS
    exp10m1f16.h
  DEPENDS
    .exp10f16_utils

=== libc/src/math/generic/CMakeLists.txt ===


add_entrypoint_object(
  canonicalize
  SRCS
    canonicalize.cpp
  HDRS
    ../canonicalize.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef
  SRCS
    canonicalizef.cpp
  HDRS
    ../canonicalizef.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef16
  SRCS
    canonicalizef16.cpp
  HDRS
    ../canonicalizef16.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef128
  SRCS
    canonicalizef128.cpp
  HDRS
    ../canonicalizef128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizel
  SRCS
    canonicalizel.cpp
  HDRS
    ../canonicalizel.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizebf16
  SRCS
    canonicalizebf16.cpp
  HDRS
    ../canonicalizebf16.h
  DEPENDS
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.bfloat16
)

add_entrypoint_object(
  iscanonical
  SRCS
    iscanonical.cpp
  HDRS
    ../iscanonical.h
)

add_entrypoint_object(
  iscanonicalf
  SRCS
    iscanonicalf.cpp
  HDRS
    ../iscanonicalf.h
)

add_entrypoint_object(
  iscanonicall
  SRCS
    iscanonicall.cpp
  HDRS
    ../iscanonicall.h
)

add_entrypoint_object(
  iscanonicalf16
  SRCS
    iscanonicalf16.cpp
  HDRS
    ../iscanonicalf16.h
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  iscanonicalf128
  SRCS
    iscanonicalf128.cpp
  HDRS
    ../iscanonicalf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  iscanonicalbf16
  SRCS
    iscanonicalbf16.cpp
  HDRS
    ../iscanonicalbf16.h
  DEPENDS
    libc.src.__support.common
    libc.src.__support.macros.config
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.bfloat16
)

add_entrypoint_object(
  ceil
  SRCS
    ceil.cpp
  HDRS
    ../ceil.h
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf
  SRCS
    ceilf.cpp
  HDRS
    ../ceilf.h
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceill
  SRCS
    ceill.cpp
  HDRS
    ../ceill.h
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
  ceilf16
  SRCS
    ceilf16.cpp
  HDRS
    ../ceilf16.h
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.nearest_integer_operations
    libc.src.__support.macros.properties.cpu_features
    libc.src.__support.macros.properties.types
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf128
  SRCS
    ceilf128.cpp
  HDRS
    ../ceilf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
    ceilbf16
  SRCS
    ceilbf16.cpp
  HDRS
    ../ceilbf16.h
  DEPENDS
    libc.src.__support.common
    libc.src.__support.FPUtil.bfloat16
    libc.src.__support.FPUtil.nearest_integer_operations
    libc.src.__support.macros.config
    libc.src.__support.macros.properties.types
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  daddl
  SRCS
    daddl.cpp
  HDRS
    ../daddl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  daddf128
  SRCS
    daddf128.cpp
  HDRS
    ../daddf128.h
 DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  ddivl
  SRCS
    ddivl.cpp
  HDRS
    ../ddivl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  ddivf128
  SRCS
    ddivf128.cpp
  HDRS
    ../ddivf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  dfmaf128
  SRCS
    dfmaf128.cpp
  HDRS
    ../dfmaf128.h
  DEPENDS
    libc.src.__support.FPUtil.fma
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  dfmal
  SRCS
    dfmal.cpp
  HDRS
    ../dfmal.h
  DEPENDS
    libc.src.__support.FPUtil.fma
)

add_entrypoint_object(
  dsqrtl
  SRCS
    dsqrtl.cpp
  HDRS
    ../dsqrtl.h
  DEPENDS
    libc.src.__support.math.dsqrtl
)

add_entrypoint_object(
  dsqrtf128
  SRCS
    dsqrtf128.cpp
  HDRS
    ../dsqrtf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.sqrt
)


add_entrypoint_object(
  dsubf128
  SRCS
    dsubf128.cpp
  HDRS
    ../dsubf128.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  dsubl
  SRCS
    dsubl.cpp
  HDRS
    ../dsubl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  cos
  SRCS
    cos.cpp
  HDRS
    ../cos.h
  DEPENDS
    libc.src.__support.math.cos
)

add_entrypoint_object(
  cosf
  SRCS
    cosf.cpp
  HDRS
    ../cosf.h
  DEPENDS
    libc.src.__support.math.cosf
)

add_entrypoint_object(
  cosf16
  SRCS
    cosf16.cpp
  HDRS
    ../cosf16.h
  DEPENDS
    libc.src.__support.math.cosf16
)

add_entrypoint_object(
  cospif
  SRCS
    cospif.cpp
  HDRS
    ../cospif.h
  DEPENDS
    libc.src.__support.math.cospif
)

add_entrypoint_object(
  cospif16
  SRCS
    cospif16.cpp
  HDRS
    ../cospif16.h
  DEPENDS
    libc.src.__support.math.cospif16
)

add_entrypoint_object(
  sin
  SRCS
    sin.cpp
  HDRS
    ../sin.h
  DEPENDS
    libc.src.__support.math.range_reduction_double
    libc.src.__support.math.sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  sinf
  SRCS
    sinf.cpp
  HDRS
    ../sinf.h
  DEPENDS
    libc.src.__support.math.range_reduction
    libc.src.__support.math.sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  sinf16
  SRCS
    sinf16.cpp
  HDRS
    ../sinf16.h
  DEPENDS
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
    libc.src.__support.math.sincosf16_utils
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sincos
  SRCS
    sincos.cpp
  HDRS
    ../sincos.h
  DEPENDS
    libc.src.__support.math.range_reduction_double
    libc.src.__support.math.sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  sinpif
  SRCS
    sinpif.cpp
  HDRS
    ../sinpif.h
  DEPENDS
    libc.src.__support.math.sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.common
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  sincosf
  SRCS
    sincosf.cpp
  HDRS
    ../sincosf.h
  DEPENDS
    libc.src.__support.math.range_reduction
    libc.src.__support.math.sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  sinpif16
  SRCS
    sinpif16.cpp
  HDRS
    ../sinpif16.h
  DEPENDS
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.math.sincosf16_utils
)

add_entrypoint_object(
  tan
  SRCS
    tan.cpp
  HDRS
    ../tan.h
  DEPENDS
    libc.src.__support.math.range_reduction_double
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  tanf
  SRCS
    tanf.cpp
  HDRS
    ../tanf.h
  DEPENDS
    libc.src.__support.math.range_reduction
    libc.src.__support.math.sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  tanf16
  SRCS
    tanf16.cpp
  HDRS
    ../tanf16.h
  DEPENDS
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
    libc.src.__support.math.sincosf16_utils
)

add_entrypoint_object(
  tanpif
  SRCS
    tanpif.cpp
  HDRS
    ../tanpif.h
  DEPENDS
    libc.src.__support.math.sincosf_utils
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
)

add_entrypoint_object(
  tanpif16
  SRCS
    tanpif16.cpp
  HDRS
    ../tanpif16.h
  DEPENDS
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.math.sincosf16_utils
)

add_entrypoint_object(
  fabs
  SRCS
    fabs.cpp
  HDRS
    ../fabs.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
  FLAGS
    MISC_MATH_BASIC_OPS_OPT
)

add_entrypoint_object(
  fabsf
  SRCS
    fabsf.cpp
  HDRS
    ../fabsf.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
  FLAGS
    MISC_MATH_BASIC_OPS_OPT
)

add_entrypoint_object(
  fabsl
  SRCS
    fabsl.cpp
  HDRS
    ../fabsl.h
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  fabsf16
  SRCS
    fabsf16.cpp
  HDRS
    ../fabsf16.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.macros.properties.architectures

=== debian/changelog ===
llvm-toolchain-snapshot (1:22~++20251225060819+966ae44e638b-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/rules: Mark usage of SLOPPY_BUILD to ease searching in the build log.
  * Update watch file, use with --force-download to fetch the integration
    testsuite.
  * Introduce an OMPD_ARCHS macro and use it.
  * Add a llvm.noclang build profile (not enabled by default).
  * Bump llvm-spirv build dependency to 21 again.
  * Introduce an LLVM_SPIRV_ARCHS macro and use it.
  * Don't run the omp autopkg test on i386. Closes: #1118644.
  * d/tests/control.in: Add test dependency on g++-multilib. Closes: #1118643.
  * d/debian-llvm-testsuite.bats: Skip test. Closes: #1118641.
    The test "pthread_cancel with libunwind compatibility" is wrong.
  * d/tests/control.in: Add test dependency on binutils-gold. Closes: #1118646.
  * Introduce CLANG_GRPC_ARCHS macro and use it.
  * Also use the grpc bits for clang on i386.
  * Add the alternate hello b-d for grpc related build dependencies.
  * Add profile to ocaml build dependencies.
  * Re(?)-enable omp on i386.
  * d/control: Only use one build profile per binary package for now. The ORing
    of build profiles seems to be not working.
  * Rename build profiles from llvm.* to pkg.llvm.*.
  * Fix some lintian warnings, override some more.
  * Clarify the libunwind package descriptions, that it is not compatible
    with glibc.
  * Only run the flang autopkg tests where flang is available.
  * Rename the LIBC_ARCHS macro to LLVM_LIBC_ARCHS, and only run the
    libllvmlibc autopkg tests where the package is available.
  * Fix removing *.pyc files and __pycache__ dirs during installation.
  * Fix some lintian warnings, override some more.
  * Copy libc++1, libc++abi1 and libomp5 symbols files from 21.
  * Build and install libflang_rt.runtime. Addresses: #1117534.
  * Fix liborc install on hurd-amd64.
  * Also call dh_python for the llvm-X.Y-tools package.
  * libunwind-X.Y-dev: Stop providing libunwind-dev. As updated in the
    package description, the unwinder is incompatible with glibc.
  * d/rules, d/*.{install,links,lintian-overrides}.in: Use a macro LLVM_LIBDIR.
  * Fix one more libclang1 lintian override.
  * Fix one more libc++-22-dev-wasm32 lintian override.
  * Update symbols files from the buildd logs, including i386.
  * Fix syntax for OR-ed build profiles.
  * clang-22-tools, llvm-22-tools: Use dh_python3 substvars.
  * liblldb-22: Move the .so symlink to the liblldb-22-dev package.
  * d/rules: Remove unnecessary use of the CURDIR macro.
  * Enable offloading on riscv64 (Aurelian Jarno).
  * Manually fix the python3 shebangs. dh_python3 can only handle one
    private directory. Also install lit first in the dh_override_install
    target, fix it there, and move it to the package from there.
  * Add build conflicts on llvm-22-runtime and clang-22, or else the
    wasm build picks up stuff from the installed llvm-22 and fails.

  [ Sylvestre Ledru ]
  * New snapshot release
  * grep is interpreting -Bno-symbolic as a context option.
  * Workaround the replaces/breaks on apt.llvm.org (upstream 167538)
  * flang: also ignore -fstack-protector-strong (happens on focal)
  * Rename ign_fail => ignore_if_fail
  * Fix file location for lintian source override.
  * mingw-w64 cross compilation is broken on focal, disable it

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 21 Dec 2025 21:31:12 +0100

=== debian/control ===
Source: llvm-toolchain-snapshot
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 11.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
    binutils-dev, lld [amd64 arm64 armel armhf i386 loong64 ppc64el riscv64 s390x],
    libxml2-dev,
    libipt-dev [amd64 i386],
    lcov, procps, help2man,
    zlib1g-dev, libzstd-dev,
    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32] | hello [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32],
    libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
    doxygen, time,
    dh-exec, dh-python, ocaml-base [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml> | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x] <!pkg.llvm.noocaml>,
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
# "| hello" is for older buster/bionic distros without spirv support
# We need to keep the constraints coherent between the two alternatives, otherwise
# hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
    llvm-spirv-22 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    spirv-tools [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    wasi-libc | hello,
    mingw-w64-common,
    libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
    libgrpc++-dev [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    protobuf-compiler-grpc [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    libprotobuf-dev [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    protobuf-compiler [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x] <!stage1> | hello [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
Build-Conflicts: oprofile, llvm-22-runtime, clang-22
Standards-Version: 4.7.2
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b snapshot
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/snapshot

# ------------- clang -------------

Package: clang-22
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc},
 libllvm22 (= ${binary:Version}),
 libclang-common-22-dev (= ${binary:Version}),
 llvm-22-linker-tools (= ${binary:Version}),
 libclang1-22 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler, objc++-compiler
Recommends: llvm-22-dev, python3, clang-tools-22
# libomp-22-dev
Suggests: clang-22-doc, wasi-libc
Breaks: clang-tools-22 (<< 1:22~++20251124083138+173600880b8f-1~exp1)
Replaces: clang-tools-22 (<< 1:22~++20251124083138+173600880b8f-1~exp1)
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-22
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-22 (= ${binary:Version}),
 python3:any, ${python3:Depends}
Breaks: clang-22 (<< 1:22~++20251124083138+173600880b8f-1~exp1)
Replaces: clang-22 (<< 1:22~++20251124083138+173600880b8f-1~exp1)
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, etc.

Package: clang-format-22
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm22 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-22
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm22 (= ${binary:Version}),
 libclang-common-22-dev (= ${binary:Version}),
 clang-tools-22, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-22
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends},
 libllvm22 (= ${binary:Version}),
 libclang-common-22-dev (= ${binary:Version}),
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-22-doc
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-22
Build-Profiles: <!pkg.llvm.noclang>
Section: libs
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-22-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-22 (= ${binary:Version}),
 libclang-common-22-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-22.

Package: libclang-common-22-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: libclang-rt-22-dev
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers.

# ------------- compiler-rt -------------

Package: libclang-rt-22-dev
Build-Profiles: <!pkg.llvm.noclang>
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - development package
 This package provides various libraries:
 .
   * builtins - Simple libraries that provide implementation of the
     low-level target-specific hooks required by code generation
     and other runtime components.
   * sanitizer runtimes - AddressSanitizer, ThreadSanitizer,
     UndefinedBehaviorSanitizer, MemorySanitizer, LeakSanitizer
     DataFlowSanitizer, etc
   * profile - Library which is used to collect coverage information.

Package: libclang-rt-22-dev-wasm32
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm32 builtins
 Provides the compiler-rt builtins for WebAssembly 32 bits

Package: libclang-rt-22-dev-wasm64
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm64 builtins
 Provides the compiler-rt builtins for WebAssembly 64 bits

Package: libclang-rt-22-dev-win
Build-Profiles: <!pkg.llvm.noclang>
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

EMPTY =
COMMA = ,
SPACE = $(EMPTY) $(EMPTY)

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform

DEB_BUILD_PROFILES := $(DEB_BUILD_PROFILES)
export DEB_BUILD_PROFILES

# FIXME: disable some PROJECTS according to build profiles
#ifeq (,$(filter pkg.llvm.noclang, $(DEB_BUILD_PROFILES)))
#  DEB_BUILD_PROFILES += pkg.llvm.noclang
#  $(warning LLVM PROFILES: enabled build profile pkg.llvm.noclang)
#endif

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
d = debian/tmp
DEB_INST		:= $(CURDIR)/$(d)

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

PYTHON3 := $(shell py3versions -d)
PY_EXT_SUFFIX := $(shell python3-config --extension-suffix)

PKG_VERSION := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_MINOR := $(shell echo $(PKG_VERSION)  | sed -rne "s,^1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
LLVM_VERSION_SNAPSHOT := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
	LLVM_VERSION_MINOR := 0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')
LLVM_DIR	= usr/lib/llvm-$(LLVM_VERSION)
LLVM_LIBDIR	= usr/lib/llvm-$(LLVM_VERSION)/lib

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
# remove +time64,+lfs once the time64_t transition starts
RUNTIMES = compiler-rt;libcxx;libcxxabi
ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
else
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
  else
    ifeq ($(DEB_HOST_ARCH),mips64el)
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
    else
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
    endif
  endif
endif

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)
DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
	NCPUS := $(shell nproc)
endif

# Check if a package meets version requirement
# Usage: $(call check_pkg_version,package-name,operator,version)
# Operators: ge (>=), gt (>), le (<=), lt (<), eq (=)
# Returns: yes or no
define check_pkg_version
$(shell v=$$(dpkg-query -W -f '$${Version}' $(1) 2>/dev/null); \
        if [ -z "$$v" ]; then \
            echo no; \
        elif dpkg --compare-versions "$$v" $(2) $(3); then \
            echo yes; \
        else \
            echo no; \
        fi)
endef

# Remove RPATH/RUNPATH from files matching a pattern
# Usage: $(call remove_rpath,file-pattern)
# Example: $(call remove_rpath,$(DEB_INST)/$(LLVM_DIR)/bin/*)
define remove_rpath
	for i in \
	  `chrpath -k $(1) 2>/dev/null | awk -F: '/R(UN)?PATH=/ {print $$$$1}'`; \
	do \
	  [ -h $$$$i ] && continue; \
	  chrpath -d $$$$i; \
	  echo "removed RPATH/RUNPATH: $$$$i"; \
	done
endef

# set this macro to anything else than "yes" to avoid generating alternative
# build dependencies on hello in the control file.
BD_ALT_HELLO = yes
ifeq ($(DERIVATIVE),Ubuntu)
BD_ALT_HELLO = no
endif

ifeq ($(BD_ALT_HELLO),yes)
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@//g;s/@END_OPTIONAL_HELLO@//g'
else
  BD_ALT_HELLO_SUBST = 's/@BEGIN_OPTIONAL_HELLO@.*@END_OPTIONAL_HELLO@//'
endif

SKIP_COMMON_PACKAGES =
# for distro builds, skip these if a newer LLVM is in the distro series
ifeq ($(DERIVATIVE),Ubuntu)
  # list series which should not have the common packages
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
else ifeq ($(DERIVATIVE),Debian)
  ifneq (,$(filter $(DISTRO), series1 series2))
    SKIP_COMMON_PACKAGES = yes
  endif
endif
# set these two when building without the common packages
#SKIP_COMMON_PACKAGES = yes
#NEW_LLVM_VERSION = 23

ifeq ($(SKIP_COMMON_PACKAGES),yes)
  COMMON_PKGS := $(shell cat debian/packages.common)
  COMMON_BUILD_DEPS = $(foreach p,$(COMMON_PKGS),$(p)$(COMMA))
  # make sure the common packages exist for the new LLVM version
  NEXT_LIBLLVM_PKG = libllvm$(NEW_LLVM_VERSION),
endif

# some object files are removed for space constraints during the build
# uncomment to keep everything during a build
# a SMALL_DISK build is 15GB + <2GB in the parent directory, the full build
# peaks out at 35GB + <2GB for the parent directory.
#SMALL_DISK = yes

# use sloppy builds to collect to
#   - ignore additional build artifacts
#   - ignore missing symbols in libraries
# look at these in the build logs and fix them in follow-up uploads
SLOPPY_BUILD =
ifeq (,$(filter $(DEB_HOST_ARCH), amd64XXX arm64XXX))
	SLOPPY_BUILD = yes
	ignore_if_fail = -
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# no 32bit support
FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64

ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
# this doesn't work, Ubuntu passes these in both positive and negative form, filter later
#    export DEB_BUILD_MAINT_OPTIONS += hardening=-stackprotector,-stackclash,-branch
endif

# flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
# based on the available memory
ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
  MEM_PER_CPU=6000
else
  MEM_PER_CPU=2100
endif

NJOBS := $(shell mt=`awk '/^(MemAvail|SwapFree)/ { mt += $$2 } END {print mt}' /proc/meminfo`; \
		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
		  'END { mt/=1024; n2 = int(mt/m); print n==1 || n2<=1 ? 1 : n2<=n ? n2 : n }' < /dev/null)

TIME_COMMAND = $(CURDIR)/debian/usage-wrapper.py $(SUMMARY_ONLY) -j $(NJOBS) --base-memory -m 4.0 -o usage-$(notdir $@)-$(DEB_HOST_ARCH).svg
TIME_BIN := $(if $(wildcard /usr/bin/time),/usr/bin/time,/bin/time)
TIME_COMMAND = $(TIME_BIN) -v
USAGE_BUILD_DEP = $(EMPTY) time,
ifneq (,$(findstring usage-wrapper, $(TIME_COMMAND)))
  ifeq ($(DERIVATIVE),Ubuntu)
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib [!i386],
    ifeq ($(DEB_HOST_ARCH),i386)
      SUMMARY_ONLY = --summary-only
    endif
  else
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
    ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
      TIME_COMMAND = $(TIME_BIN) -v
    endif
    ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32 hurd-i386 hurd-amd64))
      SUMMARY_ONLY = --summary-only
    endif
  endif
endif

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

=== debian/tests/control ===
Test-Command: ./debian/debian-llvm-testsuite.bats
Depends: @, cmake, make, g++, file, dpkg-dev, bats, bats-assert,
  binutils-gold [amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 powerpc ppc64 ppc64el s390x sparc64 x32],
  g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32],
# Comment the dbgsym package because of bug #917528
# dbgsym packages not being available in testing
# clang-22-dbgsym, libclang1-22-dbgsym
Restrictions: allow-stderr
Architecture: amd64 arm64 i386

Tests: integration-test-suite-test
Depends: @, cmake, make, g++
Restrictions: allow-stderr
Architecture: amd64 arm64

Tests: cmake-llvm-test
Depends: gcc, build-essential, cmake, llvm-22-dev

Tests: cmake-clang-test
Depends: gcc, build-essential, cmake, llvm-22-dev, clang-22, libclang-22-dev

Test-Command: python3 -c "import lldb; print(lldb.__file__); print(lldb)"
Depends: python3-lldb-22
Architecture: amd64 arm64 armel armhf i386 loong64 m68k ppc64el riscv64 s390x x32

Test-Command: python3 -c "import clang; print(clang.__file__); print(clang)"
Depends: python3-clang-22
